'/* BASIO.BAS  01.07.1997 */

function io.kbuf(inop)            '/* get key value (don't strip key buffer) */
   do                                                         '/* begin loop */
      key$ = inkey$                              '/* get key from key buffer */
   loop while len(key$) = 0                      '/* loop until a key is hit */
   if asc(key$) then                             '/* key value in first byte */
      io.kbuf = asc(key$)            '/* return key value to calling program */
   else                                      '/* zero value ("extended" key) */
      io.kbuf = asc(mid$(key$, 2)) + 128      '/* add 128 to 2nd byte of key */
   end if
end function                                   '/* return to calling program */

function io.kget(inop)                 '/* strip key buffer and wait for key */
   do                    '/* begin loop to get User key (shell or non-shell) */
      do                                  '/* begin loop to strip key buffer */
      loop while len(inkey$)        '/* loop while key buffer contains a key */
      inop = io.kbuf(0)              '/* return key value to calling program */
      if inop = KEY.WIND then              '/* User pressed F6 for DOS shell */
         cscrn = space$(4000)     '/* create a temporary screen video buffer */
         call winsave(1, 1, 80, 25, varseg(cscrn), sadd(cscrn))'/* save scrn */
         cls                   '/* clear screen prior to executing DOS shell */
         shell                                              '/* shell to DOS */
         call winrest(1, 1, 80, 25, varseg(cscrn), sadd(cscrn))'/* rest.scrn */
         cscrn = ""               '/* kill the temporary screen video buffer */
      else                         '/* User pressed a non-shell (not F6) key */
         exit do                      '/* exit loop to return User key value */
      end if
   loop                               '/* loop until User hits non-shell key */
   io.kget = inop                    '/* return key value to calling program */
end function                                   '/* return to calling program */

function io.klst(inop)           '/* strip buffer; return last key (no wait) */
   inop = 0                                  '/* initialise return key value */
   do                                                         '/* begin loop */
      ikey = io.ktst(0)                    '/* get last key pressed (if any) */
      if ikey then                             '/* key buffer contains a key */
         inop = ikey            '/* set key value to return and stay in loop */
      else                             '/* key buffer does NOT contain a key */
         exit do             '/* exit loop; return last key pressed (if any) */
      end if
   loop                             '/* loop while key buffer contains a key */
   io.klst = inop                    '/* return key value to calling program */
end function                                   '/* return to calling program */

function io.ktst(inop)                         '/* return last key (no wait) */
   key$ = inkey$                                 '/* get key from key buffer */
   if len(key$) then                           '/* key buffer contains a key */
      if asc(key$) then                          '/* key value in first byte */
         inop = asc(key$)                            '/* key value to return */
      else                                   '/* zero value ("extended" key) */
         inop = asc(mid$(key$, 2)) + 128      '/* add 128 to 2nd byte of key */
      end if
   else                                '/* key buffer does NOT contain a key */
      inop = 0                              '/* set return key value to zero */
   end if
   io.ktst = inop                    '/* return key value to calling program */
end function                                   '/* return to calling program */

function io.vadr(inop)                  '/* get video address (color or b/w) */
   regx.ax = &hf00                                '/* video-address function */
   call interrupt(&h10, regx, regx)           '/* call DOS for video address */
   if regx.ax mod 256 = 7 then                       '/* register A-low is 7 */
      io.vadr = &hb000                                '/* return b/w address */
   else                                          '/* register A-low is NOT 7 */
      io.vadr = &hb800                              '/* return color address */
   end if
end function                                   '/* return to calling program */

function io.vcls(irow1, icol1, irow2, icol2, ilin, ifil, iclr)
   iwid = icol2 - icol1 - 1                '/* total width of window minus 1 */

   select case ilin                    '/* select border line-type (0, 1, 2) */
      case 0                                        '/* 0 = invisible border */
         iul = 32                         '/* set upper-left corner to blank */
         iur = 32                        '/* set upper-right corner to blank */
         ill = 32                         '/* set lower-left corner to blank */
         ilr = 32                        '/* set lower-right corner to blank */
         ihz = 32                           '/* set horizontal-line to blank */
         ivt = 32                             '/* set vertical-line to blank */
      case 1                                      '/* 1 = single-line border */
         iul = 218                                 '/* set upper-left corner */
         iur = 191                                '/* set upper-right corner */
         ill = 192                                 '/* set lower-left corner */
         ilr = 217                                '/* set lower-right corner */
         ihz = 196                                   '/* set horizontal-line */
         ivt = 179                                     '/* set vertical-line */
      case 2                                      '/* 2 = double-line border */
         iul = 201                                 '/* set upper-left corner */
         iur = 187                                '/* set upper-right corner */
         ill = 200                                 '/* set lower-left corner */
         ilr = 188                                '/* set lower-right corner */
         ihz = 205                                   '/* set horizontal-line */
         ivt = 186                                     '/* set vertical-line */
      case else
   end select
   i = io.vdsp(char(iul) + string$(iwid, ihz) + char(iur), irow1, icol1, iclr)
   for irow = irow1 + 1 to irow2 - 1               '/* middle rows in window */
      if ifil then                                '/* fill-window flag is ON */
         i = io.vdsp(char(ivt) + space$(iwid) + char(ivt), irow, icol1, iclr)
      else                                       '/* fill-window flag is OFF */
         i = io.vdsp(char(ivt), irow, icol1, iclr)   '/* display left-border */
         i = io.vdsp(char(ivt), irow, icol2, iclr)  '/* display right-border */
      end if
   next
   i = io.vdsp(char(ill) + string$(iwid, ihz) + char(ilr), irow2, icol1, iclr)
end function                                   '/* return to calling program */

function io.vcsr(irow, icol, icsr)        '/* set cursor position [and size] */
   if icsr then                                    '/* cursor-size specified */
      locate irow + 1, icol + 1, 1                        '/* turn cursor ON */
   else                                        '/* cursor-size NOT specified */
      locate irow + 1, icol + 1, 0                       '/* turn cursor OFF */
   end if
end function                                   '/* return to calling program */

function io.vdsp(cdat, irow, icol, iclr)          '/* display data on screen */
   color iclr mod 16 + (iclr \ 128) * 16, (iclr mod 128) \ 16  '/* set color */
   locate irow + 1, icol + 1, 0                        '/* locate the cursor */
   print cdat;                                          '/* display the data */
end function                                   '/* return to calling program */

function io.vmsg(cdat, irow, iclr)                '/* display data on screen */
   lset cdsp = cdat                     '/* copy data to line-display buffer */
   color iclr mod 16 + (iclr \ 128) * 16, (iclr mod 128) \ 16  '/* set color */
   locate irow + 1, 1, 0                               '/* locate the cursor */
   print cdsp;                                          '/* display the data */
end function                                   '/* return to calling program */
