'/* BTRVLOAD.BAS Copy source text file to dest. Btrieve file */
'/*              By: Dale Thorn                              */
'/*              Rev. 13.01.2003                             */

'/* ////////////////////////////////////////////////////////
'/* OK to compile with PDQ lib [custom 'dfn.round' function]
'/* \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\

'$include: 'basdef.h'
'$include: 'btrieve.h'
'$include: 'filekill.h'
'$include: 'fileopen.h'
'$include: 'longname.h'
'$include: 'messages.h'
'$include: 'midchar.h'
'$include: 'parmstr1.h'
'$include: 'string.h'

declare function ierrproc(cerrmsg, cfilbuf, lerrptr, ierrset, ierrfil, _
                          ibuflen, istatus, imsgdisp, iexit)
declare function ifn.ldfs(cfldlst, cddfnam, cfldnam(), cfldtyp(), _
                          ifldbeg(), ifldlen(), ifldmax)
declare function io.kget(inop)
declare function io.ktst(inop)

'$include: 'basdef.bas'
'$include: 'btrieve.bas'
'$include: 'filekill.bas'
'$include: 'fileopen.bas'
'$include: 'longname.bas'
'$include: 'messages.bas'
'$include: 'midchar.bas'
'$include: 'parmstr1.bas'
'$include: 'string.bas'

dim cfilnam(9)                               'initialize Btrieve file filenames
dim cfilbuf(9)                            'initialize Btrieve file data buffers
dim ckeybuf(9)                             'initialize Btrieve file key buffers
dim cposblk(9)                         'initialize Btrieve file position blocks
dim ibuflen(9)                          'initialize Btrieve file buffer lengths
dim ikeylen(9)                             'initialize Btrieve file key lengths
dim ikeynum(9)                                  'initialize Btrieve key numbers
dim istatus(9)                                 'initialize Btrieve status codes

dim cfldnam(255)                      'field names for importing/exporting data
dim cfldtyp(255)                      'field types for importing/exporting data
dim ifldbeg(255)                    'field offsets for importing/exporting data
dim ifldlen(255)                    'field lengths for importing/exporting data

ccmd = ucase$(rtrim$(command$))         'get the user's command-line parameters
if ccmd = "" then                              'a command line was NOT supplied
   cls                                                'clear the display screen
   print
   cmsg = "Usage:  BTRVLOAD  source  dest                                 "
   ctmp = space$(4)                        'initialize the messages left margin
   ipos1 = 33                                    'position for add'l parameters
   mid$(cmsg, ipos1) = "/IC (import CSV)               "
   print ctmp; cmsg
   mid$(cmsg, 1) = "      "
   mid$(cmsg, ipos1) = "/IS (import SQL7)              "
   print ctmp; cmsg
   mid$(cmsg, ipos1) = "/IU (import BUTIL)             "
   print ctmp; cmsg
   mid$(cmsg, ipos1) = "/Sx (substitute commas for 'x')"
   print ctmp; cmsg
   mid$(cmsg, ipos1) = "/D (delete)                    "
   print ctmp; cmsg
   mid$(cmsg, ipos1) = "/N (no displays)               "
   print ctmp; cmsg
   print
   print ctmp; "'/IC', '/IS' or '/IU' import specification is required."
   print
   print ctmp; "If '/IC' specified the first line of the field script"
   print ctmp; "must contain the full path plus the Btrieve filename."
   print
   print ctmp; "If '/IS' specified the first line of the field script"
   print ctmp; "must contain the DDF table name.  The actual Btrieve"
   print ctmp; "filename is the field script name less the extension."
   print
   print ctmp; "If '/Sx' specified, substitute commas for any 'x' found."
   print ctmp; "If '/D' specified delete records from dest. before copy."
   print ctmp; "If '/N' specified do not display messages unless errors."
   print
   print ctmp; "'source' is the source text data input filename."
   print ctmp; "'dest' is the destination field script filename."
   close                              'close all files in case not closed above
   system                                   'return control to operating system
end if                              'display the usage message [above] and exit

irep = 0                               'initialize comma substitution character
ipos1 = instr(ccmd, "/S")             'user selected to replace commas with 'x'
if ipos1 then                         'user selected to replace commas with 'x'
   crep = rtrim$(mid$(ccmd, ipos1 + 2, 1))  'extract the substitute/replacement
   if crep <> "" then                  'substitute/replacement character valid!
      irep = asc(crep)                  'ASCII value for substitute/replacement
      ccmd = left$(ccmd, ipos1 - 1) + mid$(ccmd, ipos1 + 3)'remove '/Sx' switch
   else                                   'no substitute - eliminate all commas
      ccmd = left$(ccmd, ipos1 - 1) + mid$(ccmd, ipos1 + 2)'remove '/Sx' switch
   end if
end if

idelete = 0                          'initialize flag to NOT pre-delete records
iimpbut = 0                            'flag for importing data in BUTIL format
iimpcsv = 0                              'flag for importing data in CSV format
iimpsql = 0                             'flag for importing data in SQL7 format
ikeyseq = 0                           'source file key number to normal default
iphyseq = 0                         'flag to read source file in physical order
ipos1 = instr(ccmd, "/IC")                    'user selected to use CSV format?
ipos2 = instr(ccmd, "/IS")                   'user selected to use SQL7 format?
ipos3 = instr(ccmd, "/IU")                  'user selected to use BUTIL format?
if ipos1 then                                 'user selected to use CSV format!
   iimpcsv = not 0                       'set flag to import data in CSV format
   ccmd = rtrim$(left$(ccmd, ipos1 - 1) + mid$(ccmd, ipos1 + 3)) 'remove switch
elseif ipos2 then                            'user selected to use SQL7 format!
   iimpsql = not 0                      'set flag to import data in SQL7 format
   ccmd = rtrim$(left$(ccmd, ipos2 - 1) + mid$(ccmd, ipos2 + 3)) 'remove switch
elseif ipos3 then                           'user selected to use BUTIL format!
   iimpbut = not 0                     'set flag to import data in BUTIL format
   ccmd = rtrim$(left$(ccmd, ipos3 - 1) + mid$(ccmd, ipos3 + 3)) 'remove switch
else                                     'user failed to specify a valid option
   i = ifn.msgs("Invalid operation parameter", 5, 24, 79, 1, 1)
end if                                  'display error message [above] and exit

ipos1 = instr(ccmd, "/D")                   'pre-delete records from dest.file?
if ipos1 then                               'pre-delete records from dest.file!
   idelete = not 0                        'set flag ON to delete from dest.file
   ccmd = rtrim$(left$(ccmd, ipos1 - 1) + mid$(ccmd, ipos1 + 2))   'remove '/D'
end if
ipos1 = instr(ccmd, "/N")               'don't display (except error) messages?
if ipos1 then                                 'user said don't display messages
   imsgdisp = 0                                'set message display flag to OFF
   ccmd = rtrim$(left$(ccmd, ipos1 - 1) + mid$(ccmd, ipos1 + 2))   'remove '/N'
else                                          'user said OK to display messages
   imsgdisp = not 0                             'set message display flag to ON
end if

iprm = parmstr1(" " + ccmd, "", "", "", cprm())  'parse command-line parameters
if iprm <> 1 then                                 'invalid number of parameters
   i = ifn.msgs("Invalid number of parameters", 5, 24, 79, 1, 1)
end if                                  'display error message [above] and exit

if iimpcsv or iimpsql then           'import all records from text or SQL7 file
   i = ifn.ldfs(cprm(1), cddfnam, cfldnam(), cfldtyp(), _
                ifldbeg(), ifldlen(), ifldmax)   'load user-specified fieldlist
end if

if iimpbut then                      'import all records from BUTIL format file
   cfilnam(0) = cprm(1)                  'set Btrieve filename from dest. entry
elseif iimpcsv then                    'import all records from CSV format file
   cfilnam(0) = cddfnam                  'set Btrieve filename from script line
elseif iimpsql then                   'import all records from SQL7 format file
   ilen1 = len(cprm(1))                   'get length of source script filename
   ipos1 = istr.rcfn(ilen1, cprm(1), ".")       'script file extension position
   if ipos1 = 0 then                              'filename extension NOT found
      ipos1 = ilen1 + 1                           'set position to end plus one
   elseif ipos1 < ilen1 - 3 then                    'invalid extension position
      i = ifn.msgs("Invalid filename extension position", 5, 24, 79, 1, 1)
   end if                               'display error message [above] and exit
   cfilnam(0) = left$(cprm(1), ipos1 - 1)'set Btrieve filename from script file
else                                                  'invalid option specified
   i = ifn.msgs("Invalid option specified", 5, 24, 79, 1, 1)
end if                                  'display error message [above] and exit
ilen1 = len(cfilnam(0))                         'get length of Btrieve filename
ipos1 = istr.rcfn(ilen1, cfilnam(0), ".")      'Btrieve file extension position
if ipos1 = 0 then                                 'extension position NOT found
   ipos1 = ilen1 + 1                              'set position to end plus one
end if
ctxtnam = left$(cfilnam(0), ipos1 - 1)   'text filename less filename extension
crtnlnf = char(13) + char(10)         'initialize the carriage-return/line-feed
ctxtlen = space$(5)                  'initialize the BUTIL record length buffer

ibuflen(0) = 4096           'initialize Btrieve buffer length to system maximum
ikeylen(0) = 128               'initialize Btrieve key length to system maximum
ikeynum(0) = ikeyseq          'set Btrieve key number from user/default [above]
cfilbuf(0) = string$(ibuflen(0), 0)        'initialize Btrieve file data buffer
ckeybuf(0) = string$(ikeylen(0), 0)         'initialize Btrieve file key buffer
cposblk(0) = string$(128, 0)            'initialize Btrieve file position block

istatus(0) = BTRV(BTRV.OPEN, cposblk(0), cfilbuf(0), _
                  (ibuflen(0)), cfilnam(0) + " ", BTRV.NORMAL)'open Btrieve file
if istatus(0) then                              'error opening the Btrieve file
   i = ierrproc(" opening " + cfilnam(0), "", 0, 0, 0, 0, istatus(0), imsgdisp, 1)
end if                                  'display error message [above] and exit
istatus(0) = BTRV(BTRV.STAT, cposblk(0), cfilbuf(0), _
                  (ibuflen(0)), ckeybuf(0), 0)     'get the Btrieve file status
if istatus(0) then                           'error getting Btrieve file status
   i = ierrproc(" getting STAT from " + cfilnam(0), "", _
                0, 0, 0, 0, istatus(0), imsgdisp, 1)
end if                                  'display error message [above] and exit
if cvi(mid$(cfilbuf(0), 11, 2)) mod 2 then     'Btrieve file is variable-length
   ibuflen(0) = cvi(mid$(cfilbuf(0), 3, 2))     'set record length to page size
   ivarlen = not 0                              'set variable-length flag to ON
else                                          'Btrieve file NOT variable-length
   ibuflen(0) = cvi(mid$(cfilbuf(0), 1, 2))     'set record length=fixed length
   cfilbuf(0) = ""                            'reinitialize Btrieve file buffer
   cfilbuf(0) = string$(ibuflen(0), 0)        'set buffer length to STAT length
   ivarlen = 0                                 'set variable-length flag to OFF
end if

lerrptr = 1                           'initialize the error-output file pointer
ierrset = 0                            'initialize the error-output file status
ierrfil = freefile                     'initialize the error-output file number
i = ifn.kill(ierrfil, ctxtnam + ".err")    'kill any previous error-output file
open ctxtnam + ".err" for binary as ierrfil  'open error file for binary access
ltxtptr = 1                                'initialize text-output file pointer
itxtfil = freefile                          'initialize text-output file number
if iimpcsv or iimpsql then           'import all records from text or SQL7 file
   open cprm(0) for input as itxtfil          'open the source import text file
else                                 'import all records from BUTIL format file
   open cprm(0) for binary as itxtfil         'open the source import text file
end if

if idelete then              'OK to delete records from dest.file before adding
   i = ifn.msgs("Deleting from " + cfilnam(0), 5, 24, 79, 0, 0)  'standby' msg.
   itmpbuflen = ibuflen(0)            'make copy so Btrieve can't change buflen
   istatus(0) = BTRV(BTRV.GETLO, cposblk(0), cfilbuf(0), _
                     itmpbuflen, ckeybuf(0), ikeynum(0))      'get first record
   while istatus(0) = 0           'loop while records found in destination file
      istatus(0) = BTRV(BTRV.DELETE, cposblk(0), cfilbuf(0), _
                        itmpbuflen, ckeybuf(0), ikeynum(0))  'delete the record
      if istatus(0) then            'unexpected error deleting dest.file record
         i = ierrproc(" deleting record from " + cfilnam(0), cfilbuf(0), lerrptr, _
                      ierrset, ierrfil, itmpbuflen, istatus(0), imsgdisp, 1)
      elseif io.ktst(0) = 27 then                     'user pressed the ESC key
         i = BTRV(BTRV.RESET, "", "", 0, "", 0)        'close all Btrieve files
         i = ifn.msgs("ESC selected - program aborted", 5, 24, 79, 0, 1)
      end if                        'display the abort message [above] and exit
      itmpbuflen = ibuflen(0)         'make copy so Btrieve can't change buflen
      istatus(0) = BTRV(BTRV.GETNEXT, cposblk(0), cfilbuf(0), _
                        itmpbuflen, ckeybuf(0), ikeynum(0))
   wend                          'get next record from destination file [above]
   if istatus(0) <> BTRV.EOF then        'unexpected error getting first record
      i = ierrproc(" getting record from " + cfilnam(0), "", 0, ierrset, 0, 0, _
                   istatus(0), imsgdisp, 1)
   end if                               'display error message [above] and exit
end if

if imsgdisp then                              'user said OK to display messages
   i = ifn.msgs("Copying " + cfilnam(0), 5, 24, 79, 0, 0)    'OK to proceed....
end if

lrecordatt = 0                       'initialize the 'nnn records read' counter
lrecordcnt = 0                     'initialize the 'nnn records copied' counter
while not eof(itxtfil)                  'loop until we're at end of source file
   lrecordatt = lrecordatt + 1            'increment 'nnn records read' counter
   ilineok = 0                        'initialize the newline-qualified OK flag
   if iimpcsv or iimpsql then        'import all records from text or SQL7 file
      line input #itxtfil, clin            'get next text line from source file
      if rtrim$(clin) <> "" then             'non-blank line; import to Btrieve
         ctmpfilbuf = space$(ibuflen(0))      'make temp. copy of source buffer
         ilineok = not 0                    'set newline-qualified OK flag TRUE
      end if
   else                              'import all records from BUTIL format file
      get itxtfil, ltxtptr, ctxtlen    'get next recordlen spec from BUTIL file
      if not eof(itxtfil) then           'a next BUTIL data record is available
         itmpbuflen = pdqvali(ctxtlen)   'get record length from recordlen spec
         ctmpfilbuf = space$(itmpbuflen)  'make temporary copy of source buffer
         ipos1 = instr(ctxtlen, ",")     'position of comma in recordlen buffer
         ltxtptr = ltxtptr + ipos1          'move file pointer to start of data
         get itxtfil, ltxtptr, ctmpfilbuf 'get next data record from BUTIL file
         ltxtptr = ltxtptr + itmpbuflen + 2   'move file pointer to end of data
         ilineok = not 0                    'set newline-qualified OK flag TRUE
      end if
   end if
   if ilineok then                           'non-blank line; import to Btrieve
      if iimpcsv or iimpsql then     'import all records from text or SQL7 file
         if iimpsql then                     'import all records from SQL7 file
            ipos1 = instr(clin, ") values(")  'beginning of data in SQL7 string
            clin = mid$(clin, ipos1 + 9, len(clin) - ipos1 - 9)'extract the data
         end if
         ibeg = 0                                'field beginning position (-1)
         ifldndx = -1                            'initialize field number index
         iend = istr.lcfn(ibeg + 1, clin, ",")      'field ending position (+1)
         do while ibeg <= len(clin)            'loop thru the text input fields
            ifldndx = ifldndx + 1                'increment current field index
            if iimpsql then                  'import all records from SQL7 file
               cfldval = ltrim$(rtrim$(mid$(clin, ibeg + 2, iend - ibeg - 3)))
            else                            'import all records from BUTIL file
               cfldval = ltrim$(rtrim$(mid$(clin, ibeg + 1, iend - ibeg - 1)))
            end if
            if irep then                  'user specified replacement character
               for i = 1 to len(cfldval)      'loop thru the current field data
                  if midchar(cfldval, i) = irep then 'current char.was replaced
                     mid$(cfldval, i) = ","    'restore comma in field position
                  end if
               next
            end if
            i = istr.fmti(cfldval, cfldtyp(ifldndx), ifldlen(ifldndx))
            mid$(ctmpfilbuf, ifldbeg(ifldndx)) = cfldval'put field data->buffer
            ibeg = iend                              'next field begin position
            iend = istr.lcfn(ibeg + 1, clin, ",")      'next field end position
            if iend = 0 then                            'no more commas in line
               iend = len(clin) + 1                     'set end to linelen + 1
            end if
         loop
      end if
      lset cfilbuf(0) = ctmpfilbuf                'put source to Btrieve buffer
      if ivarlen then                          'Btrieve file is variable-length
         itmpbuflen = len(rtrim$(ctmpfilbuf))     'set buflen to trimmed length
         if itmpbuflen < ibuflen(0) then      'trimmed length is < fixed length
            itmpbuflen = ibuflen(0)         'set Btrieve buflen to fixed length
         end if
      else                                 'Btrieve file is NOT variable-length
         itmpbuflen = ibuflen(0)      'make copy so Btrieve can't change buflen
      end if
      istatus(0) = BTRV(BTRV.INSERT, cposblk(0), cfilbuf(0), _
                        itmpbuflen, ckeybuf(0), ikeynum(0))  'insert new record
      if istatus(0) then             'duplicates error inserting Btrieve record
         isaverr = ierrset      'save previous error status for first-time test
         i = ierrproc(" inserting record into " + cfilnam(0), cfilbuf(0), lerrptr, _
                      ierrset, ierrfil, itmpbuflen, istatus(0), imsgdisp, 0)
         if (not isaverr) and imsgdisp then'error message hasn't been displayed
            locate 7, 5, 0       'locate cursor and display 2nd message [below]
            print "Press any key to continue or press ESC to exit"
            itstkey = io.kget(0)   'get user's response to error message/prompt
            if itstkey = 27 then                      'user pressed the ESC key
               i = BTRV(BTRV.RESET, "", "", 0, "", 0)  'close all Btrieve files
               i = ifn.msgs("ESC selected - program aborted", 5, 24, 79, 0, 1)
            else                                'user did NOT press the ESC key
               i = ifn.msgs("Copying " + cfilnam(0), 5, 24, 79, 0, 0)
               locate 7, 5, 1     'locate cursor for 'nnn records read' counter
               print right$("      " + str$(lrecordatt), 7); " records read"
               locate 9, 5, 1   'locate cursor for 'nnn records copied' counter
               print right$("      " + str$(lrecordcnt), 7); " records copied"
               locate 24, 79, 0                       'hide' the display cursor
            end if
         end if
      end if
   end if
   if io.ktst(0) = 27 then                            'user pressed the ESC key
      i = BTRV(BTRV.RESET, "", "", 0, "", 0)           'close all Btrieve files
      i = ifn.msgs("ESC selected - program aborted", 5, 24, 79, 0, 1)
   else                     'record added OK and user did NOT press the ESC key
      lrecordcnt = lrecordcnt + 1       'increment 'nnn records copied' counter
   end if
   if (lrecordatt mod 100 = 0) and imsgdisp then '#records is a multiple of 100
      locate 7, 5, 1              'locate cursor for 'nnn records read' counter
      print right$("      " + str$(lrecordatt), 7); " records read"
      locate 9, 5, 1            'locate cursor for 'nnn records copied' counter
      print right$("      " + str$(lrecordcnt), 7); " records copied"
      locate 24, 79, 0                                'hide' the display cursor
   end if
wend                                  'get next record from source file [above]

if imsgdisp then                              'user said OK to display messages
   i = ifn.msgs("Copy completed", 5, 24, 79, 0, 0) 'display 'completed' message
   locate 7, 5, 1                 'locate cursor for 'nnn records read' counter
   print right$("      " + str$(lrecordatt), 7); " records read"
   locate 9, 5, 1               'locate cursor for 'nnn records copied' counter
   print right$("      " + str$(lrecordcnt), 7); " records copied"
   if ierrset then                            'error-output file status was set
      locate 11, 5, 1                          'locate cursor for error message
      print "Error records are located in the '"; ctxtnam; ".err' file"
   end if
end if
i = BTRV(BTRV.RESET, "", "", 0, "", 0)            'close all open Btrieve files
close                                              'close all non-Btrieve files
system                                              'return to operating system

function ierrproc(cerrmsg, cfilbuf, lerrptr, ierrset, ierrfil, _
                  ibuflen, istatus, imsgdisp, iexit)
   if lerrptr then                           'OK to write record to output file
      cerrlen = ltrim$(str$(ibuflen))          'length of output Btrieve buffer
      cerrbuf = cerrlen + "," + left$(cfilbuf, ibuflen) + char(13) + char(10)
      put ierrfil, lerrptr, cerrbuf                'write record to output file
      lerrptr = lerrptr + len(cerrbuf)            'increment error file pointer
   end if
   if (not ierrset) and imsgdisp then 'error message has NOT yet been displayed
      i = ifn.msgs("Error " + ltrim$(str$(istatus)) + cerrmsg, 5, 24, 79, 1, 0)
      if lerrptr then                  'error record was written to output file
         ierrset = not 0               'error record written; set error flag ON
      end if
   end if
   if iexit then                              'OK to return to operating system
      if ierrset then                         'error-output file status was set
         locate 7, 5, 1                        'locate cursor for error message
         print "Error records are located in the matching '.err' file"
      else                                    'error-output file status NOT set
         locate 6, 1, 1                       'locate cursor for exit to system
      end if
      if istatus <> BTRV.ERR then           'status != Btrieve-not-loaded error
         i = BTRV(BTRV.RESET, "", "", 0, "", 0)   'close all open Btrieve files
      end if
      close                                        'close all non-Btrieve files
      system                                        'return to operating system
   end if
end function

function ifn.ldfs(cfldlst, cddfnam, cfldnam(), cfldtyp(), _
                  ifldbeg(), ifldlen(), ifldmax) 'load user-specified fieldlist
   ifilnum = freefile                           'get next available file handle
   i = ifn.open(ifilnum, cfldlst, "s", llof)     'open the field list spec file
   if llof = 0 then                            'field list nonexistent or empty
      i = ifn.kill(ifilnum, cfldlst)           'kill the zero-length field file
      i = ifn.msgs("'" + cfldlst + "' file not found", 5, 24, 79, 1, 1)
   end if                               'display error message [above] and exit
   if eof(ifilnum) then                  'we're at EOF (no fieldspecs possible)
      i = ifn.msgs("No fieldspecs in '" + cfldlst + "' file", 5, 24, 79, 1, 1)
   end if                               'display error message [above] and exit
   line input #ifilnum, cddfnam               'get the DDF table (or file) name
   ipos1 = instr(cddfnam, ",")                 'position of comma in table name
   if ipos1 then                                 'comma was found in table name
      cddfnam = rtrim$(left$(cddfnam, ipos1 - 1))  'extract cddfnam from string
   end if
   ifldmax = -1                                 'initialize the fieldspec index
   while not eof(ifilnum)                         'loop until end of fieldspecs
      line input #ifilnum, clin                    'get the next fieldspec line
      clin = ltrim$(rtrim$(clin))                 'trim the next fieldspec line
      if clin <> "" then                        'current fieldspec is NOT blank
         ifldmax = ifldmax + 1                   'increment the fieldspec index
         ipos1 = instr(clin, ",")            '1st separator posn. in field line
         ipos2 = instr(ipos1 + 1, clin, ",") '2nd separator posn. in field line
         ipos3 = instr(ipos2 + 1, clin, ",") '3rd separator posn. in field line
         if ipos2 = 0 or ipos3 = 0 then          'separator positions NOT found
            i = ifn.msgs("Invalid fieldspec in '" + cfldlst + "' file", _
                         5, 24, 79, 1, 1)       'display error message and exit
         end if
         cfldnam(ifldmax) = ltrim$(rtrim$(mid$(clin, 1, ipos1 - 1)))
         cfldtyp(ifldmax) = ltrim$(rtrim$(mid$(clin, ipos1 + 1, ipos2 - ipos1 - 1)))
         ifldbeg(ifldmax) = pdqvali(mid$(clin, ipos2 + 1))    'field offset + 1
         ifldlen(ifldmax) = pdqvali(mid$(clin, ipos3 + 1))  'total field length
      end if
   wend
   close ifilnum                                'close the field list spec file
end function

function io.kget(inop)                       'strip key buffer and wait for key
   while inkey$ <> ""                           'begin loop to strip key buffer
   wend                                   'loop while key buffer contains a key
   do                                                               'begin loop
      ckey = inkey$                                    'get key from key buffer
   loop while ckey = ""                                'loop until a key is hit
   if asc(ckey) then                                   'key value in first byte
      io.kget = asc(ckey)                  'return key value to calling program
   else                                            'zero value ("extended" key)
      io.kget = asc(mid$(ckey, 2)) + 128       'return 2nd byte of key plus 128
   end if
end function

function io.ktst(inop)                               'return last key (no wait)
   ckey = inkey$                                       'get key from key buffer
   if ckey <> "" then                                'key buffer contains a key
      if asc(ckey) then                                'key value in first byte
         io.ktst = asc(ckey)                               'key value to return
      else                                         'zero value ("extended" key)
         io.ktst = asc(mid$(ckey, 2)) + 128    'return 2nd byte of key plus 128
      end if
   else                                      'key buffer does NOT contain a key
      io.ktst = 0                                 'set return key value to zero
   end if
end function
