'/* FIXBHDR.BAS  Copy Btrieve header page(s) from good file to bad file */
'/*              By: Dale Thorn                                         */
'/*              Rev. 23.03.1998                                        */

'$include: 'basdef.h'
'$include: 'filekill.h'
'$include: 'fileopen.h'
'$include: 'messages.h'
'$include: 'midchar.h'
'$include: 'parmstr1.h'
'$include: 'basdef.bas'
'$include: 'filekill.bas'
'$include: 'fileopen.bas'
'$include: 'messages.bas'
'$include: 'midchar.bas'
'$include: 'parmstr1.bas'
'$include: 'scrnparm.bas'

ccmd = ucase$(rtrim$(command$))            'get the DOS command-line parameters

if ccmd = "" then                     'DOS command-line parameters NOT supplied
   i = ifn.msgs("Usage:  FIXBHDR  goodfile  badfile  size[512, 1024, etc.]", _
   iofs, irow, icol, 0, 1)
end if                                  'display usage message [above] and exit

iprm = parmstr1(ccmd, cfil, cnam, cext, cprm())  'parse command-line parameters

if iprm <> 1 then                           'user input wrong no. of parameters
   i = ifn.msgs("Invalid number of parameters", iofs, irow, icol, 1, 1)
end if                  'display wrong # of parameters message [above] and exit

if cnam = "" or len(cnam) > 8 or len(cext) > 3 or instr(cext, ".") then
   i = ifn.msgs("Invalid 'goodfile' name", iofs, irow, icol, 1, 1)
end if                       'display invalid-filename message [above] and exit

cdst = cprm(0)                                'destination ('badfile') filename
idot = instr(cdst, ".")                    'destination file-extension position
if idot = 0 then                          '.' NOT found in destination filename
   idot = len(cdst) + 1                    'set '.' position to end of filename
end if
if cdst = "" or len(cdst) > 12 or idot = 1 or idot > 9 _
or (len(cdst) - idot) > 3 then                    'invalid destination filename
   i = ifn.msgs("Invalid 'badfile' name", iofs, irow, icol, 1, 1)
end if                       'display invalid-filename message [above] and exit

ihdrsiz = pdqvali(cprm(1))                  'get the user-specified header size
if ihdrsiz < 512 or ihdrsiz > 4096 or (ihdrsiz mod 512) > 0 then
   i = ifn.msgs("Invalid header size - must be multiple of 512", _
   iofs, irow, icol, 1, 1)
end if                    'display invalid header size message [above] and exit

i = ifn.open(1, cfil, "B", lof1)           'open the source file in binary mode
if lof1 < 0 then                                'user input a wildcard filespec
   i = ifn.msgs("Invalid 'goodfile' name", iofs, irow, icol, 1, 1) 'beep & exit
elseif lof1 = 0 then                          'source file nonexistent or empty
   i = ifn.kill(1, cfil)                             'kill the zero-length file
   i = ifn.msgs(cfil + " not found", iofs, irow, icol, 1, 1)     'beep and exit
end if
if lof1 <= ihdrsiz then          'source file length is invalid (m/b > ihdrsiz)
   i = ifn.msgs(cfil + " length is less than or equal to header size", _
   iofs, irow, icol, 1, 1)
end if                       'display invalid-filesize message [above] and exit

i = ifn.open(2, cdst, "B", lof2)                'open dest. file in binary mode
if lof2 < 0 then                                'user input a wildcard filespec
   i = ifn.msgs("Invalid 'badfile' name", iofs, irow, icol, 1, 1)'beep and exit
elseif lof2 = 0 then                           'dest. file nonexistent or empty
   i = ifn.kill(2, cdst)                             'kill the zero-length file
   i = ifn.msgs(cdst + " not found", iofs, irow, icol, 1, 1)     'beep and exit
end if
if lof2 <= ihdrsiz then           'dest. file length is invalid (m/b > ihdrsiz)
   i = ifn.msgs(cdst + " length is less than or equal to header size", _
   iofs, irow, icol, 1, 1)
end if                       'display invalid-filesize message [above] and exit

i = ifn.msgs("Please standby", iofs, irow, icol, 0, 0) 'hide cursor and proceed

cbuf = space$(ihdrsiz)                         'allocate the header-data buffer
get 1, 1, cbuf                             'get the header from the source file
put 2, 1, cbuf                              'write the header to the dest. file

i = ifn.msgs(cdst + " header written OK", iofs, irow, icol, 0, 1)

close                                 'close all files in case not closed above
system                                                'exit to operating system
