'/* FIXCSV.BAS Reformat CSV file for import by BTRVLOAD */
'/*            By: Dale Thorn                           */
'/*            Rev. 02.08.2002                          */

'$include: 'basdef.h'
'$include: 'filekill.h'
'$include: 'fileopen.h'
'$include: 'longname.h'
'$include: 'messages.h'
'$include: 'midchar.h'
'$include: 'parmstr1.h'
'$include: 'string.h'
'$include: 'basdef.bas'
'$include: 'filekill.bas'
'$include: 'fileopen.bas'
'$include: 'longname.bas'
'$include: 'messages.bas'
'$include: 'midchar.bas'
'$include: 'parmstr1.bas'
'$include: 'string.bas'

ccmd = ucase$(rtrim$(command$))         'get the user's command-line parameters
if ccmd = "" then                              'a command line was NOT supplied
   cls                                            'clear the DOS display screen
   locate 5, 1, 0                                   'locate cursor for messages
   print "    Usage:  FIXCSV  filename  [/N]"        'display the usage message
   print                                           'blank line between messages
   print "    If '/N' specified, don't display messages"   'optional switch msg.
   close                              'close all files in case not closed above
   system                                   'return control to operating system
end if

if right$(ccmd, 2) = "/N" then                'user said don't display messages
   imsgdisp = 0                                'set message display flag to OFF
   ccmd = rtrim$(left$(ccmd, len(ccmd) - 2))   'remove '/N' from parameter list
else                                          'user said OK to display messages
   imsgdisp = not 0                             'set message display flag to ON
end if

iprm = parmstr1(ccmd, cfil, cnam, cext, cprm())  'parse the command-line params
if cnam = "" or len(cnam) > 8 or len(cext) > 3 or instr(cext, ".") _
or iprm >= 0 then                       'user entered an invalid command syntax
   i = ifn.msgs("Invalid filename", 5, 24, 79, 1, 1)
end if                                  'display error message [above] and exit

i = ifn.open(1, cfil, "S", llof)       'open the source file in sequential mode
if llof < 0 then                                'user input a wildcard filespec
   i = ifn.msgs("Invalid filename", 5, 24, 79, 1, 1)             'beep and exit
elseif llof = 0 then                          'source file nonexistent or empty
   i = ifn.kill(1, cfil)                             'kill the zero-length file
   i = ifn.msgs(cfil + " not found", 5, 24, 79, 1, 1)            'beep and exit
end if                                  'display error message [above] and exit

if cext = "out" then                            'source file extension == "OUT"
   cdst = cnam + ".tmp"                       'set dest.file extension to "TMP"
else                                            'source file extension != "OUT"
   cdst = cnam + ".out"                       'set dest.file extension to "OUT"
end if

if imsgdisp then                              'user said OK to display messages
   i = ifn.msgs("Please standby", 5, 24, 79, 0, 0)           'OK to proceed....
end if

cdquote = char(34) + char(34)               'initialize the double-quote string
open cdst for output as 2                   'open the destination (output) file
do while not eof(1)                         'loop until destination file is EOF
   line input #1, clin                      'get next line from the source file
   clin = ltrim$(rtrim$(clin))              'trim the line from the source file
   ilinlen = len(clin)                       'get length of trimmed source line
   cout = space$(ilinlen)                      'make output copy of source line
   ifldedt = 0                                'initialize field-is-current flag
   ilinpos = 1                              'initialize position in source line
   ioutpos = 0                              'initialize position in output line
   iquotes = 0                               'initialize quoted text is ON flag
   do while ilinpos <= ilinlen               'loop until line position past EOL
      ichr = midchar(clin, ilinpos)         'character currently edited in line
      if ifldedt = 0 then                    'first character of new/next field
         ifldedt = 1                          'set the field-is-current flag ON
         select case ichr                       'current edit character in line
            case 34                            'current edit character is quote
               ilinpos = ilinpos + 1           'increment current line position
               iquotes = not 0                 'set quoted text flag to ON/TRUE
            case 44                            'current edit character is comma
               ioutpos = ioutpos + 1          'increment output buffer position
               mid$(cout, ioutpos) = char(ichr) 'put character to output buffer
               ilinpos = ilinpos + 1           'increment current line position
               ifldedt = 0                   'set the field-is-current flag OFF
            case else                            'current character is numeric?
               if ichr <> 36 then                'not '$'; add to output buffer
                  ioutpos = ioutpos + 1       'increment output buffer position
                  mid$(cout, ioutpos) = char(ichr)'put character->output buffer
               end if
               ilinpos = ilinpos + 1           'increment current line position
         end select
      else                                'NOT first character of current field
         select case ichr                       'current edit character in line
            case 34                            'current edit character is quote
               if mid$(clin, ilinpos, 2) = cdquote then    'embedded quote char.
                  ioutpos = ioutpos + 1       'increment output buffer position
                  mid$(cout, ioutpos) = char(ichr)'put character->output buffer
                  ilinpos = ilinpos + 2        'increment current line position
               else                            'single quote; end of field data
                  ilinpos = ilinpos + 1        'increment current line position
                  iquotes = 0                'set quoted text flag to OFF/FALSE
               end if
            case 44                            'current edit character is comma
               if iquotes then                 'quoted text flag is set ON/TRUE
                  if ilinpos = 1 or ilinpos = ilinlen then '1st/last field posn.
                     ispace = 0                      'set set-space flag to OFF
                  else                             'NOT 1st/last field position
                     if midchar(clin, ilinpos - 1) = 32 _   'prev.char.is space
                     or midchar(clin, ilinpos + 1) = 32 then'next char.is space
                        ispace = 0                      'set set-space flag OFF
                     else                               'next char. NOT a space
                        ispace = not 0                   'set set-space flag ON
                     end if
                  end if
                  if ispace then                'OK to replace comma with space
                     ioutpos = ioutpos + 1    'increment output buffer position
                     mid$(cout, ioutpos) = char(32) 'put space to output buffer
                  end if
                  ilinpos = ilinpos + 1        'increment current line position
               else                          'quoted text flag is set OFF/FALSE
                  ioutpos = ioutpos + 1       'increment output buffer position
                  mid$(cout, ioutpos) = char(ichr)'put character->output buffer
                  ilinpos = ilinpos + 1        'increment current line position
                  ifldedt = 0                'set the field-is-current flag OFF
               end if
            case else                            'current character is numeric?
               ioutpos = ioutpos + 1          'increment output buffer position
               mid$(cout, ioutpos) = char(ichr) 'put character to output buffer
               ilinpos = ilinpos + 1           'increment current line position
         end select
      end if
   loop
   print #2, rtrim$(cout)                    'output the current processed line
   cout = ""                                 'deallocate the temp/output buffer
   clin = ""                                  'deallocate the input line buffer
loop

close                                     'close files prior to executing shell
if imsgdisp then                              'user said OK to display messages
   shell "brow " + cdst                   'browse the destination (output) file
end if
system                                      'return control to operating system
