'/* FMAKS.BAS Make SQL7 .FLD script file from .DDF files */
'/*           By: Dale Thorn                             */
'/*           Rev. 28.06.2002                            */

'$include: 'basdef.h'
'$include: 'btrieve.h'
'$include: 'messages.h'
'$include: 'midchar.h'
'$include: 'string.h'

declare function ifn.sort(cstr1(), ival1(), ival2(), ival3(), itot)

'$include: 'basdef.bas'
'$include: 'btrieve.bas'
'$include: 'messages.bas'
'$include: 'midchar.bas'
'$include: 'string.bas'

dim cfldnam(500), ifldtyp(500), ifldpos(500), ifldlen(500)

ccmd = rtrim$(command$)
if ccmd = "" then
   cls
   locate 5, 1, 1
   print "    Usage:  FMAKS  filespec"
   print
   print "    'filespec' is INMAST, INTXDH, INTRANDP, etc., and"
   print "    is located in FILE, FIELD, INDEX.DDF dictionaries"
   print
   print "    '.DDF' files must be located in current directory"
   close
   system
end if

i = ifn.msgs("Please standby", 5, 24, 79, 0, 0)

' Open the 'FILE.DDF' dictionary....
csrcfilnam = "FILE.DDF"
isrcbuflen = 97
isrckeylen = 128
isrckeynum = 1
csrcfilbuf = string$(isrcbuflen, 0)
csrckeybuf = string$(isrckeylen, 0)
csrcposblk = string$(128, 0)
if BTRV(BTRV.OPEN, csrcposblk, csrcfilbuf, _
   (isrcbuflen), csrcfilnam + " ", BTRV.RO) _
then
   i = ifn.msgs("Error opening: " + csrcfilnam, 5, 24, 79, 1, 1)
end if

' Get the 'filespec' record from 'FILE.DDF'....
crcdnam = ccmd
itmpbuflen = isrcbuflen
lset csrckeybuf = crcdnam
isrcstatus = BTRV(BTRV.GETEQ, csrcposblk, csrcfilbuf, _
                  itmpbuflen, csrckeybuf, isrckeynum)
if isrcstatus then
   i = BTRV(BTRV.RESET, "", "", 0, "", 0)
   i = ifn.msgs("Error getting record in: " + csrcfilnam, 5, 24, 79, 1, 1)
end if

' Get the file number with which to access the fields....
cfilnum = mid$(csrcfilbuf, 1, 2)

' Get the output file name....
cdstfil = ltrim$(rtrim$(mid$(csrcfilbuf, 23, 40)))
ilen = len(cdstfil)
ipos1 = istr.rcfn(ilen, cdstfil, "\")
if ipos1 then
   cdstfil = mid$(cdstfil, ipos1 + 1)
   ilen = len(cdstfil)
end if
cdosfil = cdstfil
ipos1 = istr.rcfn(ilen, cdstfil, ".")
if ipos1 = 0 then
   ipos1 = ilen + 1
end if
if ipos1 > 9 then
   ipos1 = 9
end if
cdstfil = left$(cdstfil, ipos1 - 1) + ".FLD"

' Close the 'FILE.DDF' dictionary....
isrcstatus = BTRV(BTRV.CLOSE, csrcposblk, csrcfilbuf, _
                  itmpbuflen, csrckeybuf, isrckeynum)
if isrcstatus then
   i = BTRV(BTRV.RESET, "", "", 0, "", 0)
   i = ifn.msgs("Error closing: " + csrcfilnam, 5, 24, 79, 1, 1)
end if

' Open the 'FIELD.DDF' dictionary....
csrcfilnam = "FIELD.DDF"
isrcbuflen = 32
isrckeylen = 128
isrckeynum = 4
csrcfilbuf = string$(isrcbuflen, 0)
csrckeybuf = string$(isrckeylen, 0)
csrcposblk = string$(128, 0)
if BTRV(BTRV.OPEN, csrcposblk, csrcfilbuf, _
   (isrcbuflen), csrcfilnam + " ", BTRV.RO) _
then
   i = ifn.msgs("Error opening: " + csrcfilnam, 5, 24, 79, 1, 1)
end if

' Get the matching field records from the 'FIELD.DDF' dictionary....
itmpbuflen = isrcbuflen
lset csrckeybuf = cfilnum + string$(3, 0)
isrcstatus = BTRV(BTRV.GETGE, csrcposblk, csrcfilbuf, _
                  itmpbuflen, csrckeybuf, isrckeynum)
imaxseq = -1
while isrcstatus = 0 and mid$(csrcfilbuf, 3, 2) = cfilnum
   ' We may have a field record from FIELD.DDF....
   itstlen = cvi(mid$(csrcfilbuf, 28, 2))
   if itstlen > 0 then
      ctmpnam = ltrim$(rtrim$(mid$(csrcfilbuf, 5, 20)))
      imaxseq = imaxseq + 1
      cfldnam(imaxseq) = ctmpnam
      ifldtyp(imaxseq) = asc(mid$(csrcfilbuf, 25, 1))
      ifldpos(imaxseq) = cvi(mid$(csrcfilbuf, 26, 2)) + 1
      ifldlen(imaxseq) = itstlen
   end if
   itmpbuflen = isrcbuflen
   isrcstatus = BTRV(BTRV.GETNEXT, csrcposblk, csrcfilbuf, _
                     itmpbuflen, csrckeybuf, isrckeynum)
wend

' Now sort the fields by fieldname....
i = ifn.sort(cfldnam(), ifldtyp(), ifldpos(), ifldlen(), imaxseq + 1)

' Now that we're ready to process fields, open the destination text file....
open cdstfil for output as 1
print #1, ucase$(crcdnam); ",0"
for ifldseq = 0 to imaxseq
   ' We now have a field record from FIELD.DDF....
   cfldpos = ltrim$(str$(ifldpos(ifldseq)))
   cfldlen = ltrim$(str$(ifldlen(ifldseq)))
   select case ifldtyp(ifldseq)
      case DTYP.AUTOINC, _
           DTYP.BOOLEAN, _
           DTYP.INTEGER, _
           DTYP.NOTE1, _
           DTYP.NOTE2
         if ifldlen(ifldseq) = 4 then
            cfldtyp = "L"
         elseif ifldlen(ifldseq) = 2 then
            cfldtyp = "I"
         elseif ifldlen(ifldseq) = 1 then
            cfldtyp = "A"
         else
            i = ifn.msgs("Unspecified fieldtype: " + _
                         ltrim$(str$(ifldtyp(ifldseq))), 5, 24, 79, 1, 1)
         end if
      case DTYP.BFLOAT
         if ifldlen(ifldseq) = 8 then
            cfldtyp = "M8"
         elseif ifldlen(ifldseq) = 4 then
            cfldtyp = "M4"
         else
            i = ifn.msgs("Unspecified fieldtype: " + _
                         ltrim$(str$(ifldtyp(ifldseq))), 5, 24, 79, 1, 1)
         end if
      case DTYP.BTRVDATE
         cfldtyp = "D"
      case DTYP.BTRVTIME
         cfldtyp = "T"
      case DTYP.FLOAT
         if ifldlen(ifldseq) = 8 then
            cfldtyp = "I8"
         elseif ifldlen(ifldseq) = 4 then
            cfldtyp = "I4"
         else
            i = ifn.msgs("Unspecified fieldtype: " + _
                         ltrim$(str$(ifldtyp(ifldseq))), 5, 24, 79, 1, 1)
         end if
      case DTYP.STRING
         cfldtyp = "S"
      case else
         i = ifn.msgs("Unspecified fieldtype: " + _
                      ltrim$(str$(ifldtyp(ifldseq))), 5, 24, 79, 1, 1)
   end select
   print #1, cfldnam(ifldseq); ","; cfldtyp; ","; cfldpos; ","; cfldlen; ",1"
next

' All done - close files and exit....
i = BTRV(BTRV.RESET, "", "", 0, "", 0)
i = ifn.msgs("FMAKS output file: " + cdstfil, 5, 24, 79, 0, 1)
close
system

function ifn.sort(cstr1(), ival1(), ival2(), ival3(), itot)   'Shellsort arrays
   'Note: istr.sort sorts zero-based-index arrays. 'itot' is the
   '      total of elements and not the upper bound of the array.
   irdx = itot \ 2                  'initialize sort radix to midpoint of array
   while irdx > 0                     'loop until radix reaches a value of zero
      for itap = irdx - 1 to itot - 2              'loop thru top part of array
         for ilap = (itap - irdx + 1) to 0 step -irdx  'loop thru lower portion
            if ucase$(cstr1(ilap)) > ucase$(cstr1(ilap + irdx)) then'low > high
               swap cstr1(ilap), cstr1(ilap + irdx)'swap lower value/high value
               swap ival1(ilap), ival1(ilap + irdx)'swap lower value/high value
               swap ival2(ilap), ival2(ilap + irdx)'swap lower value/high value
               swap ival3(ilap), ival3(ilap + irdx)'swap lower value/high value
            else                                 'low value <= high-index value
               exit for                          'no swap here; exit inner loop
            end if
         next
      next
      irdx = irdx \ 2              'divide radix by 2; test for > 0 at loop end
   wend
end function
