'/* PROCTXT1.BAS  Process text to insure proper ASCII format */
'/*               By: Dale Thorn                             */
'/*               Rev. 06.02.2001                            */

defstr c
defint i
deflng l

declare function midchar%(cstr, ipos)
declare function pdqvali%(cstr)

dim char(255)                         'replacement for Basic CHR$ function
for i = 0 to 255                        'loop thru the ASCII character set
   char(i) = chr$(i)        'set each array element to its CHR$ equivalent
next

cls
locate 5, 5, 1
ccmd = rtrim$(command$)
if ccmd = "" then
   print "Usage:  PROCTXT1  inputfile  [wrapsize]"
   system
else
   print "Please standby"
   locate 24, 79, 0
end if

itab = 8

ipos = instr(ccmd, " ")
if ipos then
   iwrp = pdqvali(mid$(ccmd, ipos + 1))
   if iwrp < 40 or iwrp > 250 then
      iwrp = 80
   end if
   ccmd = left$(ccmd, ipos - 1)
else
   iwrp = 80
end if

ibuflen = 8000
iseglen = 4000

cbuf = space$(ibuflen)
crcd = space$(ibuflen)
clin = space$(320)

ifil = 0

open ccmd for input as #1

while inkey$ <> char(27) and not eof(1)
   line input #1, csrc
   ipos = instr(csrc, ".")
   if ipos = 0 then
      ipos = len(rtrim$(csrc)) + 1
   end if
   if mid$(ucase$(csrc), ipos + 1, 3) = "OUT" then
      cdst = left$(csrc, ipos - 1) + ".TMP"
   else
      cdst = left$(csrc, ipos - 1) + ".OUT"
   end if
   open csrc for binary as 2
   llof = lof(2)
   if llof = 0 then
      locate 5, 5, 1
      print csrc + " invalid or not found"
      beep
      close
      system
   end if
   ibuf = llof \ ibuflen
   imod = llof mod ibuflen
   imax = ibuf + abs(imod > 0)
   ifil = ifil + 1
   open cdst for output as #3
   ircd = 0
   while ircd <= imax
      if ircd = 0 then
         ircd = 1
         get 2, 1, crcd
         lset cbuf = crcd
         iptr = 0
         if llof < ibuflen then
            ilen = llof
         else
            ilen = ibuflen
         end if
      end if
      gosub procbuff
      if ircd < imax then
         get 2, clng(ircd) * ibuflen + 1, crcd
         mid$(cbuf, iseglen + 1) = crcd
      end if
      if ircd + 1 = imax then
         if imod >= iseglen then
            ilen = ilen + iseglen
            imod = imod - iseglen
         else
            ilen = ilen + imod
            imod = 0
         end if
      else
         if ircd + 1 < imax then
            ilen = ilen + iseglen
         end if
      end if
      if ilen > 0 then
         gosub procbuff
      end if
      mid$(cbuf, iseglen + 1) = mid$(crcd, iseglen + 1)
      ircd = ircd + 1
      if ircd = imax then
         if imod >= iseglen then
            ilen = ilen + iseglen
            imod = imod - iseglen
         else
            ilen = ilen + imod
            imod = 0
         end if
      else
         ilen = ilen + iseglen
      end if
   wend
   close #3
   close #2
wend

locate 5, 5, 1
print "Processing complete"
beep
close
system

procbuff:
   while iptr < ilen and iptr < iseglen
      lset clin = ""
      iext = 0
      ipos = 0
      while iptr < ilen and not iext
         iptr = iptr + 1
         ichr = midchar(cbuf, iptr)
         select case ichr
            case 10, 13
               gosub righttrim
               print #3, left$(clin, itrm)
               lset clin = ""
               ipos = 0
               if iptr < ilen then
                  ichr = midchar(cbuf, iptr + 1)
                  if ichr = 10 or ichr = 13 then
                     iptr = iptr + 1
                  end if
               end if
               if iptr >= iseglen then
                  iext = not 0
               end if
              'break;
            case 26
              'break;
            case 33 to 255
               ipos = ipos + 1
               mid$(clin, ipos) = char(ichr)
              'break;
            case else
               if ichr = 9 then
                  if itab > 0 then
                     ipos = ipos + itab
                  else
                     if ipos > 0 then
                        if midchar(clin, ipos) <> 32 then
                           ipos = ipos + 1
                        end if
                     end if
                  end if
               else
                  ipos = ipos + 1
               end if
              'break;
         end select
         if ipos > iwrp then
            ichr = 0
            for ix = iwrp + 1 to 1 step -1
               if midchar(clin, ix) = 32 then
                  ichr = ix
                  ix = 1
               end if
            next
            if ichr = 0 then
               ichr = iwrp + 1
            end if
            print #3, left$(clin, ichr - 1)
            lset clin = mid$(clin, ichr)
            ipos = ipos - ichr + 1
            if midchar(clin, 1) = 32 then
               if midchar(clin, 2) <> 32 then
                  lset clin = mid$(clin, 2)
                  ipos = ipos - 1
               end if
            end if
         end if
      wend
      if ipos > 0 then
         gosub righttrim
         print #3, left$(clin, itrm)
      end if
   wend
   mid$(cbuf, 1) = mid$(cbuf, iseglen + 1)
   iptr = iptr - iseglen
   ilen = ilen - iseglen
return

righttrim:
   itrm = 0
   for ix = len(clin) to 1 step -1
      if midchar(clin, ix) <> 32 then
         itrm = ix
         ix = 1
      end if
   next
return
