'/* PROCTXT2.BAS  Process text into a single ASCII file      */
'/*               By: Dale Thorn                             */
'/*               Rev. 20.11.1998                            */

defstr c
defint i
deflng l

declare function pdqvali%(cstr)

dim char(255)                              'replacement for Basic CHR$ function
for i = 0 to 255                             'loop thru the ASCII character set
   char(i) = chr$(i)             'set each array element to its CHR$ equivalent
next

cls
locate 5, 5, 1
ccmd = rtrim$(command$)
if ccmd = "" then
   print "Usage:  PROCTXT2  inputfile  destfile  [tabsize]"
   system
else
   ipos = instr(ccmd, " ")
   if ipos = 0 then
      print "Error:  Missing destfile parameter"
      system
   else
      print "Please standby"
      locate 24, 79, 0
   end if
end if

csrc = left$(ccmd, ipos - 1)                     'set the source file list name
cdst = mid$(ccmd, ipos + 1)               'set the destination output file name
while left$(cdst, 1) = " "
   cdst = mid$(cdst, 2)
wend

ipos = instr(cdst, " ")
if ipos then
   itab = pdqvali(mid$(cdst, ipos + 1))
   if itab < 3 or itab > 8 then
      itab = 8
   end if
   cdst = left$(cdst, ipos - 1)
else
   itab = 8
end if

csep = string$(79, "")                            'file/segment separator line
cnam = left$(csep, 3)      'separators enclose filename at begin/end of segment

inam = not 0                    'add filenames to begin and end of each segment
init = not 0                'flag prevents writing separators before first file

open csrc for input as #1
open cdst for output as #2

while not eof(1)
   line input #1, cfil
   do
      ipos = instr(cfil, " ")
      if ipos then
         if instr(cfil, ".") = 0 then
            mid$(cfil, ipos) = "."
         else
            cfil = left$(cfil, ipos - 1) + mid$(cfil, ipos + 1)
         end if
      else
         exit do
      end if
   loop
   open cfil for input as #3
   if init then
      init = 0
   else
      print #2, csep
      print #2, csep
      print #2, csep
   end if
   if inam then
      print #2, cnam; cfil; cnam
   end if
   ilin = 0
   ilininit = not 0
   while not eof(3)
      line input #3, clin
      do
         ilen = instr(clin, char(9)) - 1
         if ilen < 0 then
            exit do
         end if
         clin = left$(clin, ilen) + space$(itab - ilen mod itab) _
               + mid$(clin, ilen + 2)
      loop
      gosub righttrim
      if itrm then
         clin = left$(clin, itrm)
         if ilin then
            if not ilininit then
               print #2, ""
            end if
            ilin = 0
         end if
         ilininit = 0
         print #2, clin
      else
         ilin = not 0
      end if
      if inkey$ = char(27) then
         close
         system
      end if
   wend
   if inam then
      print #2, cnam; cfil; cnam
   end if
   close #3
wend

locate 5, 5, 1
print "Processing complete"
beep
close
system

righttrim:
   itrm = 0
   for ix = len(clin) to 1 step -1
      if asc(mid$(clin, ix, 1)) <> 32 then
         itrm = ix
         ix = 1
      end if
   next
return
