'/* TBROW.BAS Indexed ASCII-file command-line browse program */
'/*           By: Dale Thorn                                 */
'/*           Rev. 08.08.2002                                */

'$include: 'basdef.h'
'$include: 'basio.h'
'$include: 'browsx.h'
'$include: 'btrieve.h'
'$include: 'filekill.h'
'$include: 'fileopen.h'
'$include: 'longname.h'
'$include: 'messages.h'
'$include: 'midchar.h'
'$include: 'parmstr1.h'
'$include: 'string.h'

type cpas                               'variables passed to set-color function
   clrno1 as integer                           'color #1 for set-color function
   clrno2 as integer                           'color #2 for set-color function
   clrno3 as integer                           'color #3 for set-color function
   clrno4 as integer                           'color #4 for set-color function
   clrno5 as integer                           'color #5 for set-color function
   clrno6 as integer                           'color #6 for set-color function
   clrno7 as integer                           'color #7 for set-color function
   colbeg as integer                             'begin window column on screen
   coltot as integer                            'total window columns on screen
   datcol as integer                                 'begin data display column
   datlen as integer                                  'data display text length
   ms1max as integer                                  'max. color area messages
   ms2max as integer                                'max. color select messages
   rowbeg as integer                                  'begin data row on screen
   rowend as integer                                  'final data row on screen
   filnam as string * 13                        'filename of system colors file
   sepchr as string * 1                         'source/dest.filespec separator
end type

declare function ifn.setclr(bc as bcnf, cp as cpas, cdat(), cvdb(), _
                            cmsg0(), cmsg1(), iptr(), iofs)
declare function its.cdir(cdir, cstr, iadd)
declare function its.init(cfil, cnam, cwrd, ircdlen, _
itxtlen, cdat(), ckey(), crcd(), iptr())
declare function its.pars(cbuf, cdat)

'$include: 'basdef.bas'
'$include: 'basiob1.bas'
'$include: 'tbrowsx.bas'
'$include: 'filekill.bas'
'$include: 'fileopen.bas'
'$include: 'longname.bas'
'$include: 'messages.bas'
'$include: 'midchar.bas'
'$include: 'parmstr1.bas'
'$include: 'string.bas'
'$include: 'scrnparm.bas'
'$include: 'textparm.bas'

dim cp as cpas                         '/* vars.passed to set-color function */
dim clin(2)                             '/* used to read lines from WMAK.PRT */
dim cmrk(20)                    '/* used to save previous key(0) "bookmarks" */
dim cmsg0(9)                                '/* allocate color area messages */
dim cmsg1(9)                              '/* allocate color select messages */

clin(1) = space$(12)                   '/* temp. buffer for filename padding */
i = ifn.open(1, "textbrow.dir", "S", llof)  '/* open the file-selection file */
cdir = ""                                '/* initialize the filenames buffer */
if llof then                           '/* the file-selection file was found */
   do while not eof(1)                  '/* not yet EOF; read next data line */
      line input #1, clin(0)                        '/* fill the read-buffer */
      if rtrim$(clin(0)) <> "" then                 '/* valid filename found */
         lset clin(1) = ucase$(clin(0))   '/* pad filename in 12-byte buffer */
         i = its.cdir(cdir, clin(1), not 0) '/* add name to filename "stack" */
      end if
   loop
   close 1                                 '/* close the file-selection file */
else                               '/* the file-selection file was NOT found */
   i = ifn.kill(1, "textbrow.dir")             '/* kill the zero-length file */
end if

idirlen = len(cdir)                       '/* set length of filename "stack" */
if command$ = "" then          '/* command-line parameters were NOT supplied */
   if idirlen then          '/* filename was provided by file-selection file */
      ccmd = ucase$(rtrim$(left$(cdir, 12))) '/* set command-line pass value */
   else                     '/* filename NOT provided by file-selection file */
      i = ifn.msgs("Usage:  TEXTBROW  filename", iofs, irow, icol, 0, 1)
   end if                     '/* display the usage message and exit [above] */
else                               '/* command-line parameters were supplied */
   ccmd = ucase$(rtrim$(command$))       '/* set the command-line pass value */
end if

iprm = parmstr1(ccmd, cfil, cnam, cext, cprm())'/* process command-line data */
if cnam = "" or len(cnam) > 8 or len(cext) > 3 _     '/* invalid filename or */
or instr(cext, ".") or iprm >= 0 then              '/* additional parameters */
   i = ifn.msgs("Invalid filename", iofs, irow, icol, 1, 1)
end if                 '/* display invalid-filename message [above] and exit */

cwrd = "$%'0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz"
i = ifn.open(1, "wmak.wrd", "S", llof)  '/* open the in-word characters file */
if llof then                       '/* the in-word characters file was found */
   if not eof(1) then                    '/* not yet EOF; read the data line */
      line input #1, cwrd                           '/* fill the cwrd buffer */
   end if
   close 1                             '/* close the in-word characters file */
else                           '/* the in-word characters file was NOT found */
   i = ifn.kill(1, "wmak.wrd")                 '/* kill the zero-length file */
end if                        '/* set cwrd to the default characters [above] */

if its.init(cfil, cnam, cwrd, ircdlen, itxtlen, cdat(), ckey(), crcd(), iptr()) then
   i = ifn.msgs(cfil + " not valid or not found", iofs, irow, icol, 1, 1)
end if      '/* error and error-file name returned; display and exit [above] */

i = ifn.open(iunisav, "textbrow.sav", "B", llof)'/* open saved-bookmark file */
if llof > 0 and llof = (idirlen \ 4) * 5 then   '/* possible valid bookmarks */
   csav = space$(llof)               '/* allocate the saved-bookmarks buffer */
   get iunisav, clng(1), csav            '/* fill the saved-bookmarks buffer */
   if left$(csav, idirlen) = cdir then  '/* files match; bookmarks are valid */
      for ipos = idirlen to llof - 3 step 3      '/* loop thru the bookmarks */
         cmrk((ipos - idirlen) \ 3) = mid$(csav, ipos + 1, 3)
      next              '/* build the array from the saved bookmarks [above] */
   end if
end if
csav = ""                        '/* reinitialize the saved-bookmarks buffer */

if command$ = "" then          '/* command-line parameters were NOT supplied */
   mid$(ckey(0), len(ckey(0)) - 2) = cmrk(0) '/* put 1st bookmark to 1st key */
   idirptr = 1                '/* point to the first filename in the "stack" */
else                               '/* command-line parameters were supplied */
   lset clin(1) = cfil           '/* pad command-line name in 12-byte buffer */
   i = its.cdir(cdir, clin(1), not 0)       '/* add name to filename "stack" */
   idirptr = idirlen + 1                '/* point to the filename just added */
end if

i = ifn.open(ifil, "wmak.prt", "S", llof)     '/* open the print-driver file */
if llof then                             '/* the print-driver file was found */
   for ilin = 0 to 1                '/* loop thru the "ON" and "OFF" buffers */
      if not eof(ifil) then             '/* not yet EOF; read next data line */
         line input #ifil, clin(ilin)               '/* fill the file buffer */
         i = its.pars(rtrim$(clin(ilin)), cdat(ilin + 4, 0))  '/* set values */
      else                                  '/* end-of-file has been reached */
         cdat(ilin + 4, 0) = ""             '/* kill the print-driver buffer */
      end if
      if cdat(ilin + 4, 0) = "" then             '/* current buffer is empty */
         cdat(abs(ilin = 0) + 4, 0) = ""           '/* kill the other buffer */
         exit for                               '/* exit the processing loop */
      end if
   next
   close ifil                                '/* close the print-driver file */
else                                 '/* the print-driver file was NOT found */
   i = ifn.kill(ifil, "wmak.prt")              '/* kill the zero-length file */
end if

i = ifn.open(iuniclr, "textbrow.clr", "B", llof) '/* open system colors file */
cbuf = space$(9)                          '/* allocate the color-file buffer */
if llof = 9 then                        '/* the system colors file was found */
   get iuniclr, clng(1), cbuf              '/* load the color specifications */
else                          '/* the color-specification file was NOT found */
   mid$(cbuf, 1) = char(ICLR.HDR)                     '/* header title color */
   mid$(cbuf, 2) = char(ICLR.HDR)                  '/* footer messages color */
   mid$(cbuf, 3) = char(ICLR.DATA)                      '/* scroll bar color */
   mid$(cbuf, 4) = char(ICLR.WARN)                       '/* data area color */
   mid$(cbuf, 5) = char(ICLR.WIN)                    '/* window border color */
   mid$(cbuf, 6) = char(ICLR.EDIT)                    '/* search field color */
   mid$(cbuf, 7) = char(ICLR.ERR)                    '/* error message color */
   mid$(cbuf, 8) = char(ICLR.MSG)                 '/* standard message color */
   mid$(cbuf, 9) = char(ICLR.LABEL)                  '/* column titles color */
   put iuniclr, clng(1), cbuf              '/* save the color specifications */
end if
bc.clrhdr = midchar(cbuf, 1)                          '/* header title color */
bc.clrftr = midchar(cbuf, 2)                       '/* footer messages color */
bc.clrbar = midchar(cbuf, 3)                            '/* scroll bar color */
bc.clrdat = midchar(cbuf, 4)                             '/* data area color */
bc.clrwin = midchar(cbuf, 5)                         '/* window border color */
bc.clredt = midchar(cbuf, 6)                          '/* search field color */
bc.clrerr = midchar(cbuf, 7)                         '/* error message color */
bc.clrmsg = midchar(cbuf, 8)                      '/* standard message color */
bc.clrttl = midchar(cbuf, 9)                         '/* column titles color */
close iuniclr                                   '/* close system colors file */

bc.auxkey = 2                          '/* initial value; set to browse mode */
bc.colmin = 0                      '/* window start column (-1 = autoconfig) */
bc.edtmax = 0                                   '/* no. of search fields - 1 */
bc.filmax = 0                        '/* no. of files accessed by browse - 1 */
bc.fldmax = 0                                '/* no. of fields on window - 1 */
bc.holdln = not 0                  '/* TRUE if OK to hold one line on paging */
bc.linext = 1                       '/* window-border line width (0, 1 or 2) */
bc.linint = 0                               '/* internal-line width (0 or 1) */
bc.padext = 0                            '/* TRUE if OK to pad l&r of screen */
bc.padint = 0                          '/* TRUE if OK to pad all data fields */
bc.prinit = 0                               '/* printing-initialization flag */
bc.rowmin = 0                         '/* window start row (-1 = autoconfig) */
bc.rowtot = irow                   '/* window size in rows (-1 = autoconfig) */
bc.xkey01 = KEY.COLOR                                 '/* quit-browse key #1 */
bc.xkey02 = KEY.ENTER                                 '/* quit-browse key #2 */
bc.xkey03 = KEY.ESC                                   '/* quit-browse key #3 */
bc.xkey04 = KEY.HELP                                  '/* quit-browse key #4 */
bc.xkey05 = KEY.TABLT                                 '/* quit-browse key #5 */
bc.xkey06 = KEY.TABRT                                 '/* quit-browse key #6 */

cmsg0(0) = "1. Header title color"
cmsg0(1) = "2. Footer messages color"
cmsg0(2) = "3. Scroll bar color"
cmsg0(3) = "4. Data display color"
cmsg0(4) = "5. Window border color"
cmsg0(5) = "6. Search field color"
cmsg0(6) = "** Select the color area to be changed **"
cmsg0(7) = "** Press Esc to exit the color changes **"
cmsg1(0) = " Sample data for color selection"
cmsg1(1) = "** Press left/right arrows to toggle FG colors **"
cmsg1(2) = "** Press left/right tabkey to toggle BG colors **"
cmsg1(3) = "** Press Esc to redisplay the color selections **"
cmsg1(4) = "Sample search data"

i = ifn.msgs("", iofs, irow, icol, 0, 0)               'clear the entire screen
do                                       'begin loop to process user selections
   i = browse(bc, cdat(), ckey(), ckvl(), crcd(), cvdb(), iptr())  'call BROWSE
   select case bc.auxkey                  'select on "quit" key from BROWSE SUB
      case KEY.COLOR                               'color modification selected
         cp.clrno1 = bc.clrhdr                              'header title color
         cp.clrno2 = bc.clrftr                              'footer msgs. color
         cp.clrno3 = bc.clrbar                                'scroll bar color
         cp.clrno4 = bc.clrdat                                 'data area color
         cp.clrno5 = bc.clrwin                             'window border color
         cp.clrno6 = bc.clredt                              'search field color
         cp.clrno7 = 112                                   'DOS std.fg/bg color
         cp.colbeg = bc.colmin                             'begin window column
         cp.coltot = bc.colcnt + 2                        'total window columns
         cp.datcol = icolbeg + 1                     'begin data display column
         cp.datlen = 31                               'data display text length
         cp.ms1max = 8                                 'max.color area messages
         cp.ms2max = 5                               'max.color select messages
         cp.rowbeg = bc.rowbeg                        'begin data row on screen
         cp.rowend = irowbeg + bc.rowcnt - 1          'final data row on screen
         cp.filnam = "textbrow.clr"             'filename of system colors file
         cp.sepchr = ""                         'source/dest.filespec separator
         i = ifn.setclr(bc, cp, cdat(), cvdb(), cmsg0(), cmsg1(), iptr(), iofs)
         bc.clrhdr = cp.clrno1                              'header title color
         bc.clrftr = cp.clrno2                              'footer msgs. color
         bc.clrbar = cp.clrno3                                'scroll bar color
         bc.clrdat = cp.clrno4                                 'data area color
         bc.clrwin = cp.clrno5                             'window border color
         bc.clredt = cp.clrno6                              'search field color
      case KEY.ENTER               'full-context BROW selected; get data record
         i = ibr.btrv(BTRV.GETEQ, crcd(1, 0), crcd(0, 0), iptr(4, 0), ckey(0), ipos)
         ibeg = 1
         iwid = len(rtrim$(left$(crcd(0, 0), ipos)))
         ibeg2 = ircdlen - len(ltrim$(mid$(crcd(0, 0), ipos))) + 1
         iwid2 = len(rtrim$(crcd(0, 0))) - ibeg2 + 1
         if iwid2 > iwid then
            ibeg = ibeg2
            iwid = iwid2
         end if
         for ipos = ibeg to ibeg + iwid - 1          'loop thru the data record
            ichr = midchar(crcd(0, 0), ipos)  'current character in data record
            select case ichr                       'select on current character
               case 32, 34, 37, 47, 94, 96 'characters: '"', '%', '/', '^', '`'
                  mid$(crcd(0, 0), ipos) = char(ichr + 157)'"pad" the character
               case 60, 62, 124                  'DOS characters: '<', '>', '|'
                  mid$(crcd(0, 0), ipos) = char(ichr + 128)'"pad" the character
               case else
            end select
         next                                 'do the full-context BROW [below]
         shell "br25 " + cfil + "/T" + mid$(crcd(0, 0), ibeg, iwid) _
                              + "/T" + str$(cvl(mid$(crcd(1, 0), 17, 4)) + 1)
      case KEY.HELP                'activate "help" line; reset footer messages
         for ilin = 3 to 5                       'loop thru the footer messages
            swap cdat(0, ilin), cdat(0, ilin + 3)  'exchange 'old' and new msgs
         next
      case KEY.TABLT, _                   'move to previous window if available
           KEY.TABRT                          'move to next window if available
         cmrk((idirptr - 1) \ 12) = right$(ckey(0), 3)   'save current bookmark
         if bc.auxkey = KEY.TABLT then               'User pressed tab-left key
            idirptr = idirptr - 12   'move file-select pointer to previous name
         else                                       'User pressed tab-right key
            idirptr = idirptr + 12       'move file-select pointer to next name
         end if
         if idirptr < 1 then               'file-select pointer is < first name
            idirptr = len(cdir) - 11     'set file-select pointer to final name
         else                             'file-select pointer is >= first name
            if idirptr > len(cdir) then    'file-select pointer is > final name
               idirptr = 1               'set file-select pointer to first name
            end if
         end if          'get new file name from "stack"
         i = parmstr1(rtrim$(mid$(cdir, idirptr, 12)), cfil, cnam, cext, cprm())
         if its.init(cfil, cnam, cwrd, ircdlen, itxtlen, cdat(), ckey(), crcd(), _
         iptr()) then   'initialize BROWSE array data and return possible error
            i = ifn.msgs(cfil + " not valid or not found", iofs, irow, icol, 1, 1)
         end if        'error and error-file returned; display and exit [above]
         mid$(ckey(0), len(ckey(0)) - 2) = cmrk((idirptr - 1) \ 12)'AddBookmark
      case else
         cmrk((idirptr - 1) \ 12) = right$(ckey(0), 3)   'save current bookmark
         exit do                     'not a loop-process key, quit this program
   end select
loop                  'loop while the "quit" key is one of the selections above

i = ifn.kill(iunisav, "textbrow.sav")        'kill the old saved-bookmarks file
open "textbrow.sav" for binary as iunisav      'reopen the saved-bookmarks file
cdir = left$(cdir, idirlen)               'set to length less command-line name
put iunisav, clng(1), cdir             'write filenames to saved-bookmarks file
for indx = 0 to idirlen \ 12 - 1                'loop thru the filename "stack"
   if cmrk(indx) = "" then                     'bookmark was NOT previously set
      cmrk(indx) = string$(3, 0)                  'set a dummy bookmark pointer
   end if              'write bookmark pointers to saved-bookmarks file [below]
   put iunisav, clng(idirlen) + indx * 3 + 1, cmrk(indx)
next

color bc.clrdat mod 16, bc.clrdat \ 16 'set the color for the clear-screen call
locate 1, 1, 1                         'locate cursor for the clear-screen call
cls                                'clear the screen before exiting the program
close                                 'close all files in case not closed above
system                                      'return control to operating system

function its.cdir(cdir, cstr, iadd)   'add/delete filenames to filename "stack"
   if iadd then                                     'this is an "add name" call
      cdir = cdir + cstr              'add the filename to the filename "stack"
   else                                           'this is a "delete name" call
      for ipos = 1 to len(cdir) step 12         'loop thru the filename "stack"
         if mid$(cdir, ipos, 12) = cstr then   'match found in filename "stack"
            cdir = left$(cdir, ipos - 1) + mid$(cdir, ipos + 12)
            exit for          'name found for deletion; delete the name [above]
         end if
      next   '*** NOTE: When the delete function above is actually implemented,
   end if    '********* we will have to be sure to delete the correct file in
end function '********* case of a duplicate, to maintain correct positioning.

function ifn.setclr(bc as bcnf, cp as cpas, cdat(), cvdb(), _
                    cmsg0(), cmsg1(), iptr(), iofs)
   cbuf = space$(9)                             'allocate the color-file buffer
   iclrfil = freefile                            'get system colors file handle
   open rtrim$(cp.filnam) for binary as iclrfil    'open the system colors file
   get iclrfil, clng(1), cbuf                    'load the color specifications
   ikey = 0                                  'initialize user-entered key value
   while ikey <> KEY.ESC                 'loop to display color area selections
      color cp.clrno7 mod 16, cp.clrno7 \ 16   'set color for clear-screen call
      cls                                             'clear the display screen
      for indx = 0 to cp.ms1max - 3          'loop thru the color area messages
         i = io.vdsp(cmsg0(indx), cp.rowbeg + indx * 2, cp.colbeg + 1, cp.clrno7)
      next                             'display the color area messages [above]
      imsgcol = cp.colbeg + (cp.coltot - len(cmsg0(indx))) \ 2  'message column
      i = io.vdsp(cmsg0(indx + 0), cp.rowbeg + indx * 2 + 1, imsgcol, cp.clrno7)
      i = io.vdsp(cmsg0(indx + 1), cp.rowbeg + indx * 2 + 3, imsgcol, cp.clrno7)
      ikey = io.kget(0)                            'get the selection-key value
      iseq = ikey - 48                            'get select-sequence from key
      if iseq >= 1 and iseq <= cp.ms1max - 2 then'color-area selection 1 - max.
         iclr = midchar(cbuf, iseq)                   'get existing color value
         ifgd = iclr mod 16                           'set the foreground color
         ibgd = iclr \ 16                             'set the background color
         while ikey <> KEY.ESC                   'loop to process color changes
'------------------------------ Non-Generic Code ------------------------------
            bc.clrhdr = cp.clrno1                     'reset header title color
            bc.clrftr = cp.clrno2                     'reset footer msgs. color
            bc.clrdat = cp.clrno4                     'reset data display color
            bc.clrwin = cp.clrno5                    'reset window border color
            i = ibr.scrn(bc, cdat(), cvdb(), iptr())  'display the basic screen
            cp.clrno5 = cp.clrno4                      'copy data display color
'------------------------------------------------------------------------------
            for irow = cp.rowbeg to cp.rowend - 4      'loop thru the data rows
               if irow = cp.rowend - 6 _
               or irow = cp.rowend - 8 _
               or irow = cp.rowend - 11 then       'hilite this source filespec
                  i = io.vdsp(cmsg1(0), irow, cp.datcol, cp.clrno5)
               else                            'show normal color this filespec
                  i = io.vdsp(cmsg1(0), irow, cp.datcol, cp.clrno4)
               end if                 'display separator [below] and dest. data
               i = io.vdsp(rtrim$(cp.sepchr), irow, cp.datlen + 2, cp.clrno6)
               i = io.vdsp(mid$(cmsg1(0), 2), irow, cp.datlen + 3, cp.clrno4)
            next                         'display normal color this row [above]
'------------------------------ Non-Generic Code ------------------------------
            cp.clrno5 = bc.clrwin                    'reset window border color
'------------------------------------------------------------------------------
            i = io.vdsp(cmsg1(0), cp.rowbeg, cp.datcol, cp.clrno3)'scroll color
            imsgcol = cp.colbeg + (cp.coltot - len(cmsg1(1))) \ 2 'message col.
            for indx = 1 to cp.ms2max - 2  'loop thru the color select messages
               i = io.vdsp(cmsg1(indx), cp.rowend + indx - 3, imsgcol, cp.clrno7)
            next                     'display the color select messages [above]
            i = io.vdsp(cmsg1(indx), cp.rowend + 3, cp.colbeg + 2, cp.clrno6)
            ikey = io.kget(0)                         'get the toggle-key value
            select case ikey                        'select on toggle-key value
               case KEY.CSRLT                'user toggled a FG color decrement
                  ifgd = (ifgd - 1) mod 8 + 8   'decrement the foreground color
                  if ifgd = ibgd + 8 then        'foreground matches background
                     ibgd = (ibgd + 1) mod 8    'increment the background color
                  end if
               case KEY.CSRRT                'user toggled a FG color increment
                  ifgd = (ifgd + 1) mod 8 + 8   'increment the foreground color
                  if ifgd = ibgd + 8 then        'foreground matches background
                     ibgd = (ibgd + 7) mod 8    'decrement the background color
                  end if
               case KEY.TABLT                'user toggled a BG color decrement
                  ibgd = (ibgd + 7) mod 8       'decrement the background color
                  if ifgd = ibgd + 8 then        'foreground matches background
                     ifgd = (ifgd + 1) mod 8 + 8    'increment foreground color
                  end if
               case KEY.TABRT                'user toggled a BG color increment
                  ibgd = (ibgd + 1) mod 8       'increment the background color
                  if ifgd = ibgd + 8 then        'foreground matches background
                     ifgd = (ifgd - 1) mod 8 + 8    'decrement foreground color
                  end if
               case else                         'user pressed a non-toggle key
                  if ikey <> KEY.ESC then          'user pressed an invalid key
                     ikey = 0                 'clear key to skip color settings
                     beep                    'warn user and get next toggle key
                  end if
            end select
            if ikey then                             'user toggled to new color
               iclr = ifgd + ibgd * 16                  'set single-value color
               select case iseq                          'select on color areas
                  case 1                                         'color area #1
                     cp.clrno1 = iclr                    'set new area #1 color
                  case 2                                         'color area #2
                     cp.clrno2 = iclr                    'set new area #2 color
                  case 3                                         'color area #3
                     cp.clrno3 = iclr                    'set new area #3 color
                  case 4                                         'color area #4
                     cp.clrno4 = iclr                    'set new area #4 color
                  case 5                                         'color area #5
                     cp.clrno5 = iclr                    'set new area #5 color
                  case 6                                         'color area #6
                     cp.clrno6 = iclr                    'set new area #6 color
                  case else
               end select
               mid$(cbuf, iseq) = char(iclr)      'put new color to file buffer
            end if
         wend
         ikey = 0                'clear ESC key so we don't exit the outer loop
      elseif ikey <> KEY.ESC then        'user did invalid color-area selection
         beep                                'warn and get next color selection
      end if
   wend
   put iclrfil, clng(1), cbuf                    'save the color specifications
   close iclrfil                               'close color specifications file
end function

function its.init(cfil, cnam, cwrd, ircdlen, itxtlen, cdat(), ckey(), crcd(), iptr())
   i = ibr.btrv(BTRV.RESET, crcd(1, 0), crcd(0, 0), 0, ckey(0), 0)
   i = ifn.open(ifil, cfil, "B", llof)           '/* open the main text file */
   if llof < 0 then                         '/* user input wildcard filespec */
      its.init = 1                '/* return error indicating cfil not found */
      exit function                            '/* return to calling program */
   elseif llof = 0 then                        '/* valid text file NOT found */
      i = ifn.kill(ifil, cfil)                 '/* kill the zero-length file */
      its.init = 1                '/* return error indicating cfil not found */
      exit function                            '/* return to calling program */
   end if
   close ifil                                   '/* close the main text file */
   cndx = cnam + ".ptr"                                  '/* index-file name */
   i = ifn.open(ifil, cndx, "B", llof)               '/* open the index file */
   if llof then                             '/* a valid index file was found */
      lptr = llof - 3                           '/* position of offset-value */
      cbuf = space$(2)                          '/* make offset-value buffer */
      get ifil, lptr, cbuf                          '/* get the offset-value */
      ioffset = cvi(cbuf)         '/* offset from column #1 in original text */
      get ifil, lptr + 2, cbuf                       '/* get the word-length */
      iwrdlen = cvi(cbuf)              '/* maximum word-length from WMAK.EXE */
      close ifil                                    '/* close the index file */
   else                                       '/* valid index file NOT found */
      i = ifn.kill(ifil, cndx)                 '/* kill the zero-length file */
      cfil = cndx               '/* return index file name not found in cfil */
      its.init = 1                '/* return error indicating cndx not found */
      exit function                            '/* return to calling program */
   end if                  '/* display invalid-file message [above] and exit */

   crcd(0, 0) = string$(ircdlen, 0)           '/* BROWSE data record buffers */
   crcd(1, 0) = string$(128, 0) + cwrd        '/* BROWSE file control blocks */
   mid$(crcd(1, 0), 11) = mki$(itxtlen)               '/* put txtlen in cfcb */
   mid$(crcd(1, 0), 13) = mki$(ioffset)               '/* put offset in cfcb */
   mid$(crcd(1, 0), 15) = mki$(iwrdlen)              '/* put wordlen in cfcb */
   ckey(0) = string$(iwrdlen + 3, 0)                    '/* file-access keys */
   ckey(10) = string$(iwrdlen, "C") + "SSS"           '/* key-masking buffer */
   ckey(20) = string$(iwrdlen, 0) + left$(mkl$(1), 3)'/* minimum file #0 key */
   ckey(21) = string$(iwrdlen, 255) + left$(mkl$(lptr - 3), 3)  '/* max. key */

   '/* Note on main title message [below]:                                   */
   '/*  The main title will display inside a box if there are no surrounding */
   '/*  spaces in the text, otherwise it'll be superimposed on the top line. */

   cdat(0, 0) = " Indexed Text Browse of " + cfil + " "'/* main header title */
   cdat(0, 1) = ""                   '/* subheader if OK to enter NEW record */
   cdat(0, 2) = "No records found. Press any key to exit."'/* option message */
   cdat(0, 3) = ""          '/* 1st footer swap-message (RESERVED BY SYSTEM) */
   cdat(0, 4) = ""          '/* 2nd footer swap-message (RESERVED BY SYSTEM) */
   cdat(0, 5) = ""          '/* 3rd footer swap-message (RESERVED BY SYSTEM) */
   cdat(0, 6) = "Enter-Text   F2-Color   F6-DOS Window"  '/* 1st footer msg. */
   cdat(0, 7) = "F9-Print   Tab-Next Window   Esc-Exit"  '/* 2nd footer msg. */
   cdat(0, 8) = ""                                       '/* 3rd footer msg. */
   cdat(2, 0) = ""                     '/* 1st row title for BROWSE field #0 */
   cdat(3, 0) = ""                     '/* 2nd row title for BROWSE field #0 */
   cdat(6, 10) = ""         '/* left-pad default data for file #0 key buffer */
   iptr(0, 0) = 1       '/* begin position of BROWSE field #0 in data record */
   iptr(1, 0) = ircdlen         '/* length of BROWSE field #0 in data record */
   iptr(2, 0) = iptr(1, 0)               '/* screen width of BROWSE field #0 */
   iptr(3, 0) = 0            '/* file number containing BROWSE field #0 data */

   '/* <search data>  Note: column number is relative to BROWSE screen begin */

   iptr(5, 0) = 0                    '/* BROWSE field no. of search field #0 */
   iptr(5, 10) = 1           '/* BROWSE screen column no. of search field #0 */
   iptr(6, 0) = iwrdlen           '/* BROWSE screen width of search field #0 */
   iptr(7, 0) = 0                                '/* BROWSE file key numbers */
   iptr(7, 10) = 0               '/* number of segments (-1) for file #0 key */
   iptr(8, 0) = 1             '/* begin position for file #0 key, segment #0 */
   iptr(8, 10) = iwrdlen              '/* length for file #0 key, segment #0 */
   if len(cdat(0, 6)) + len(cdat(0, 7)) <= ircdlen - 3 then'/* 1-line fit OK */
      cdat(0, 6) = cdat(0, 6) + "   " + cdat(0, 7)'/* combine 1st & 2nd msgs */
      cdat(0, 7) = ""                          '/* clear the 2nd-row message */
   end if               '/* combine messages if both fit on one line [above] */
   i = ibr.btrv(BTRV.OPEN, crcd(1, 0), crcd(0, 0), ircdlen, cfil, 0)
   its.init = 0                               '/* return zero error (all OK) */
end function

function its.pars(cbuf, cdat)   'return driver string from ASCII-numeric buffer
   do                        'begin loop to remove commas from the current line
      ipos = instr(cbuf, ",")               'comma position in the current line
      if ipos then                       'a comma was found in the current line
         mid$(cbuf, ipos) = " "        'blank out the comma in the current line
      else                             'comma NOT found (or all commas removed)
         exit do                               'end of comma removal; exit loop
      end if
   loop
   cdat = ""                                 'initialize the driver data string
   iend = 1                             'initialize the end of numeric position
   do while iend <= len(cbuf)           'begin loop to process the current line
      ipos = istr.lcsp(iend, cbuf, " ")         'get the begin numeric position
      iend = istr.lcfn(ipos, cbuf, " ") 'blank space following numeric position
      ival = pdqvali(mid$(cbuf, ipos, iend - ipos))   'get driver numeric value
      if ival > 0 and ival <= 255 then            'this is a valid driver value
         cdat = cdat + char(ival)             'add the value to the data string
      else                                 'this is NOT a valid character value
         cdat = ""                                 'kill the driver data string
         exit do                                  'exit the process-driver loop
      end if
   loop
end function
