'/* TBROWSX.BAS Indexed ASCII-file Browse/select module */
'/*             By: Dale Thorn                          */
'/*             Rev. 08.08.2002                         */

dim cdat(7, 23), ckey(29), ckvl(23), crcd(2, 10), cvdb(27), iptr(18, 23)
dim bc as bcnf                                   'Browse-options pass structure

function browse(bc as bcnf, cdat(), ckey(), ckvl(), crcd(), cvdb(), iptr())
   bc.chradj = bc.linext - abs(bc.linext > 0)'used to set line-width characters
   bc.padadj = abs(bc.padint) * 2                      'internal pad amount * 2
   if bc.padint then                         'OK to pad internal display fields
      bc.padext = 0                    'no external pad when internal pad is on
   end if
   icoltot = 1 + abs(bc.padext) * 2       'initialize total Browse window width
   bc.titles = 0                      'initialize the field (column) title rows
   ifld = 0                                'loop thru the Browse display fields
   iextlen = iptr(2, ifld) + bc.padadj              'padded display-field width
   if icoltot + iextlen < 80 then           'total width OK; process this field
      icoltot = icoltot + iextlen + 1           'accumulated total window width
      iptr(2, ifld) = iextlen            'put padded field width in width array
   end if
   if bc.rowtot = -1 then                       'total rows = -1; do autoconfig
      bc.rowtot = 25                          'set row total = 25 (full screen)
   end if
   if bc.colmin = -1 then                  'start column = -1; do autocentering
      bc.colmin = (80 - icoltot) \ 2        'set begin column for autocentering
   end if
   if bc.rowmin = -1 then                     'start row = -1; do autocentering
      bc.rowmin = (25 - bc.rowtot) \ 2         'set begin row for autocentering
   end if
   bc.colmax = bc.colmin + icoltot - 1                'Browse window end column
   bc.colcnt = icoltot - 2                      'total length of displayed data
   indx = 0                                 'loop thru the Browse search fields
   iptr(5, indx + 10) = iptr(5, indx + 10) + bc.colmin     'adjust begin column
   iptr(6, indx + 10) = iptr(5, indx + 10) + iptr(6, indx)       'end column +1
   bc.ftrcnt = 0                               'initialize footer-message count
   iftrlen = 0                           'initialize max. footer-message length
   for indx = 3 to 5                        'loop thru the footer-message array
      if len(cdat(0, indx)) then                'a footer was supplied this row
         bc.ftrcnt = bc.ftrcnt + 1              'increment footer-message count
      end if
      if iftrlen < len(cdat(0, indx)) then       'current footer is the longest
         iftrlen = len(cdat(0, indx))         'reset max. footer-message length
      end if
   next
   bc.ftrcol = bc.colmin + (icoltot - iftrlen) \ 2     'set footer start column
   bc.hdrcol = bc.colmin + (icoltot - len(cdat(0, 0))) \ 2 'header start column
   bc.hdrpos = (82 - len(cdat(0, 0))) \ 2      'header start column for reports
   bc.hdrrow = (left$(cdat(0, 0), 1) > " ")  'TRUE if 1st char. of header > ' '
   bc.rowmax = bc.rowmin + bc.rowtot - 1                 'Browse window end row
   bc.rowbeg = bc.rowmin + abs(bc.hdrrow) * 2 + bc.titles + 1   'first data row
   bc.rowend = bc.rowmax - abs(bc.edtmax >= 0) _                 'last data row
   * 2 - abs(bc.ftrcnt > 0) - bc.ftrcnt - 1
   bc.rowcnt = bc.rowend - bc.rowbeg + 1         'total Browse window data rows
   iedtrow = bc.rowend + 2                      'Browse window search field row
   ikeylen = len(ckey(0))                       'length of main file-access key
   if bc.auxkey <> 1 then                  'OK to display initial Browse window
      bc.dsprow = -1                          'initialize current (display) row
      bc.cdtl = "-"                        'bottom-left connector in header box
      bc.cdtr = "-"                       'bottom-right connector in header box
      bc.cllt = "\"                        'bottom-left corner of Browse window
      bc.clrt = "/"                       'bottom-right corner of Browse window
      bc.cstd = "-"                        'down-side connector for int'l lines
      bc.cstl = "|"                        'left-side connector for int'l lines
      bc.cstr = "|"                       'right-side connector for int'l lines
      bc.cstu = "-"                          'up-side connector for int'l lines
      ckey(22) = string$(ikeylen, 0)      'lowest valid key found in data range
      ckey(23) = ckey(22)                'highest valid key found in data range
      ckey(24) = ckey(22)                   'used internally in key comparisons
      ckey(25) = ckey(22)                   'used internally in key comparisons
      ckey(26) = ckey(22)               'NULL buffer for init's and comparisons
      ckey(27) = ckey(22)            'key buffer saves beginning print position
      ckey(28) = ckey(22)                   'key-buffer for related-record gets
      indx = 0                              'loop thru the Browse search fields
      cdat(6, indx) = space$(iptr(6, indx))      'allocate search-field buffers
      ckvl(0) = string$(ikeylen, 255)     'initial value of 1st-row data buffer
      for irow = 1 to bc.rowcnt - 1      'loop thru the Browse window data rows
         ckvl(irow) = ckey(22)             'initialize the data row key buffers
      next
      for irow = 0 to 25                     'loop thru the video display array
         cvdb(irow) = space$(bc.colcnt)       'allocate the video display array
      next
      cvdb(26) = string$(bc.colcnt, "-")                  'Browse window border
      lset ckey(28) = ckey(0)                       'hold the current-key value
      i = ibr.hkey(ckey(), ckvl(), crcd(), iptr())        'get current high key
      i = ibr.lkey(ckey(), ckvl(), crcd(), iptr())         'get current low key
      lset ckey(0) = ckey(28)                    'restore the current-key value
      i = ibr.scrn(bc, cdat(), cvdb(), iptr())       'display the Browse window
   end if
   if ckey(0) = ckey(26) then              'incoming key = NULLs (do HOME call)
      ikey = KEY.HOME                          '"user" key for HOME positioning
   else                                  'incoming key <> NULLs (do GFPOS call)
      ikey = KEY.GFPOS                        '"user" key for Get-From-POSition
   end if
   bc.prtque = 0                                       'printing is active flag
   ibufkey = 0                           'initialize keyboard buffered-key flag
   ibypass = (bc.auxkey <> 1)   'set keyboard-bypass ON for initial positioning
   iedtcol = iptr(5, 10)                'current position of search-cell cursor
   iexit = (bc.auxkey = 0)                           'set exit-from-Browse flag
   iprtset = 0                                           'print mode is ON flag
   do                                                   'begin main Browse loop
      if ibypass then                    'automatic (non-user) key-select is ON
         ibypass = 0                     'reset automatic (non-user) key-select
      else                              'automatic (non-user) key-select is OFF
         i = io.vcsr(iedtrow, iedtcol, ICSR.COVR)   'turn cursor ON for key-get
         if ibufkey then                 'buffered-key state for searches is ON
            ikey = io.kbuf(0)         'get the next buffered key (wait if none)
         else                           'buffered-key state for searches is OFF
            ikey = io.kget(0)       'get the next unbuffered key (wait for key)
         end if
         i = io.vcsr(bc.rowmax, bc.colmax, 0)    'turn cursor OFF after key-get
         if (ikey < 32 and ikey <> KEY.TABRT _
         or ikey > 127 and ikey <> KEY.CSRRT) _
         and ibufkey then                            'OK to clear search fields
            ibufkey = 0                             'turn buffered-key flag OFF
            iedtcol = iptr(5, 10)       'set current search column to beginning
            indx = 0                               'loop thru the search fields
            lset cdat(6, indx) = ""             'clear the search field buffers
            i = io.vdsp(cdat(6, indx), iedtrow, _
            iptr(5, indx + 10), bc.clrwin)       'clear search fields on window
         end if
      end if
      select case ikey                    'select user-hit or default key value
         case KEY.CSRDN                                        'Down-cursor key
            if ckvl(0) <> ckey(23) and ckey(23) > ckey(26) or bc.dsprow > 0 then
               bc.scroll = -1                     'set scroll flag to scroll up
               lset ckey(0) = ckvl(bc.dsprow)          'fill current-key buffer
               istat = ibr.btrv(BTRV.GETGT, crcd(1, 0), _ 'get record from file
               crcd(0, 0), iptr(4, 0), ckey(0), iptr(7, 0))
               i = ibr.mask(ckey(10), ckey(24), ckey(25), ckey(0), ckey(21))
               if istat = 0 and ckey(24) <= ckey(25) then   'valid record found
                  i = ibr.scrl(bc, ckvl(), cvdb(), iptr())'scroll data up 1 row
                  i = ibr.disp(bc, cdat(), ckey(), crcd(), cvdb(), iptr())
                  lset ckvl(bc.dsprow) = ckey(0)            'save new key value
               else                                     'valid record NOT found
                  if bc.dsprow > 0 then           'more than 1 record on screen
                     i = ibr.scrl(bc, ckvl(), cvdb(), iptr())  'scroll up 1 row
                  end if
                  lset ckvl(bc.dsprow) = ckey(26)        'clear last-row buffer
                  lset cvdb(bc.dsprow) = cvdb(23)           'clear video buffer
                  i = io.vdsp(cvdb(23), bc.dsprow + _         'clear screen row
                  bc.rowbeg, bc.colmin + 1, bc.clrdat)
                  bc.dsprow = bc.dsprow - 1                 'decrement last row
               end if
            else                          'no records available for down-cursor
               if ckey(23) = ckey(26) then  'no records available in data range
                  ikey = KEY.HOME                       'set "user" key to HOME
                  ibypass = not 0                    'set keyboard bypass to ON
               end if
            end if
         case KEY.CSRUP                                          'Up-cursor key
            if ckvl(0) > ckey(26) and ckvl(0) <> ckey(22) then
               lset ckey(0) = ckvl(0)                  'fill current-key buffer
               istat = ibr.btrv(BTRV.GETLT, crcd(1, 0), _ 'get record from file
               crcd(0, 0), iptr(4, 0), ckey(0), iptr(7, 0))
               i = ibr.mask(ckey(10), ckey(24), ckey(25), ckey(0), ckey(20))
               if istat = 0 and ckey(24) >= ckey(25) then   'valid record found
                  bc.scroll = 1                      'set scroll to scroll down
                  i = ibr.scrl(bc, ckvl(), cvdb(), iptr())'scroll the data down
                  isavrow = bc.dsprow              'save the last row displayed
                  bc.dsprow = 0                 'set row# to display at 1st row
                  i = ibr.disp(bc, cdat(), ckey(), crcd(), cvdb(), iptr())
                  lset ckvl(0) = ckey(0)          'save key value in row-buffer
                  bc.dsprow = isavrow + abs(isavrow < bc.rowcnt - 1) 'restore #
               else                               'a valid record was NOT found
                  ikey = KEY.HOME                       'set "user" key to HOME
                  ibypass = not 0                    'set keyboard bypass to ON
               end if
            end if
         case KEY.END                                                  'End key
            if ckvl(0) <> ckey(23) and ckey(23) > ckey(26) or bc.dsprow > 0 then
               lset ckey(0) = ckey(21)              'begin at highest key value
               istat = ibr.btrv(BTRV.GETLE, crcd(1, 0), _ 'get record from file
               crcd(0, 0), iptr(4, 0), ckey(0), iptr(7, 0))
               i = ibr.mask(ckey(10), ckey(24), ckey(25), ckey(0), ckey(20))
               if istat = 0 and ckey(24) >= ckey(25) then   'valid record found
                  bc.dsprow = 0                          'set row# to first row
                  i = ibr.disp(bc, cdat(), ckey(), crcd(), cvdb(), iptr())
                  i = ibr.cdat(bc, ckey(), ckvl(), cvdb())    'clear other rows
                  lset ckvl(0) = ckey(0)      'save key value in 1st-row buffer
               else                               'a valid record was NOT found
                  ikey = KEY.HOME                       'set "user" key to HOME
                  ibypass = not 0                    'set keyboard bypass to ON
               end if
            else                         'already @ end or record(s) not avail.
               if ckey(23) = ckey(26) then        'data record(s) not available
                  ikey = KEY.HOME                       'set "user" key to HOME
                  ibypass = not 0                    'set keyboard bypass to ON
               end if
            end if
         case KEY.GFPOS                         'get-from-position using ckey()
            bc.dsprow = -1                             'begin at first data row
            istat = ibr.btrv(BTRV.GETGE, crcd(1, 0), _    'get record from file
            crcd(0, 0), iptr(4, 0), ckey(0), iptr(7, 0))
            i = ibr.mask(ckey(10), ckey(24), ckey(25), ckey(0), ckey(23))
            if istat = 0 and ckey(23) > ckey(26) and ckey(24) <= ckey(25) then
               do while istat = 0 and ckey(24) <= ckey(25) _
               and bc.dsprow < bc.rowcnt - 1     'get records until screen full
                  bc.dsprow = bc.dsprow + 1       'increment display row number
                  i = ibr.disp(bc, cdat(), ckey(), crcd(), cvdb(), iptr())
                  lset ckvl(bc.dsprow) = ckey(0)    'save key in current buffer
                  istat = ibr.btrv(BTRV.GETNEXT, crcd(1, 0), _ 'get next record
                  crcd(0, 0), iptr(4, 0), ckey(0), iptr(7, 0))
                  i = ibr.mask(ckey(10), ckey(24), ckey(25), ckey(0), ckey(23))
               loop
               if bc.dsprow < bc.rowcnt - 1 then        'EOF before screen full
                  i = ibr.cdat(bc, ckey(), ckvl(), cvdb())   'clear remain.rows
               end if
            else                                           'record(s) not found
               ikey = KEY.END                            'set "user" key to END
               ibypass = not 0                       'set keyboard bypass to ON
            end if
         case KEY.HOME                                                'Home key
            if ckvl(0) > ckey(26) and ckvl(0) <> ckey(22) then
               isavrow = bc.dsprow                    'save last row# displayed
               bc.dsprow = -1                      'initialize first row number
               lset ckey(0) = ckey(20)      'begin at lowest key value in range
               istat = ibr.btrv(BTRV.GETGE, crcd(1, 0), _     'get first record
               crcd(0, 0), iptr(4, 0), ckey(0), iptr(7, 0))
               i = ibr.mask(ckey(10), ckey(24), ckey(25), ckey(0), ckey(21))
               if istat = 0 and ckey(24) <= ckey(25) then   'valid record found
                  do while istat = 0 and ckey(24) <= ckey(25) _
                  and bc.dsprow < bc.rowcnt - 1     'get data until screen full
                     bc.dsprow = bc.dsprow + 1    'increment display row number
                     i = ibr.disp(bc, cdat(), ckey(), crcd(), cvdb(), iptr())
                     lset ckvl(bc.dsprow) = ckey(0) 'save key in current buffer
                     istat = ibr.btrv(BTRV.GETNEXT, crcd(1, 0), _'get next rcd.
                     crcd(0, 0), iptr(4, 0), ckey(0), iptr(7, 0))
                     i = ibr.mask(ckey(10), ckey(24), ckey(25), ckey(0), ckey(21))
                  loop
               else                               'a valid record was NOT found
                  if isavrow >= 0 then                 'some data WAS displayed
                     bc.dsprow = -1            'set row# to clear ALL data rows
                     i = ibr.cdat(bc, ckey(), ckvl(), cvdb())       'clear data
                  end if
                  if len(cdat(0, 2)) then  'disp.    "No records" msg. if appl.
                     i = io.vmsg(cdat(0, 2), bc.rowmax, bc.clrerr)     'message
                     beep                                      'user-alert tone
                     i = io.kget(0)                 'wait for key after message
                  end if
                  lset ckey(0) = ckey(26)             'return NULLs in pass-key
                  bc.auxkey = -1                  'no-records return key number
                  iexit = not 0                   'set exit-from-Browse flag ON
               end if
               if bc.dsprow < isavrow and not iexit then     'data rows deleted
                  i = ibr.cdat(bc, ckey(), ckvl(), cvdb())   'clear excess rows
               end if
            end if
         case KEY.PGDN                                           'Page-down key
            if ckvl(0) <> ckey(23) and ckey(23) > ckey(26) or bc.dsprow > 0 then
               i = ibr.mask(ckey(10), ckey(24), ckey(25), ckvl(bc.dsprow), ckey(23))
               if ckey(24) < ckey(25) then                'add'l data available
                  lset ckey(0) = ckvl(bc.dsprow)     'move last-row data to 1st
                  if bc.holdln then            'hold-line-for-paging flag is ON
                     ioper = BTRV.GETGEKEY       'set get-from-current file op.
                  else                        'hold-line-for-paging flag is OFF
                     ioper = BTRV.GETGTKEY       'set get-from-greater file op.
                  end if
                  istat = ibr.btrv(ioper, crcd(1, 0), _   'get record from file
                  crcd(0, 0), iptr(4, 0), ckey(0), iptr(7, 0))
                  if istat then                   'next record is NOT available
                     ikey = KEY.END                      'set "user" key to END
                  else                                'next record is available
                     ikey = KEY.GFPOS                  'set "user" key to GFPOS
                  end if
               else                                   'add'l data NOT available
                  ikey = KEY.END                         'set "user" key to END
               end if
               ibypass = not 0                       'set keyboard bypass to ON
            else                        'add'l data NOT available for page-down
               if ckey(23) = ckey(26) then          'no record(s) are available
                  ikey = KEY.HOME                       'set "user" key to HOME
                  ibypass = not 0                    'set keyboard bypass to ON
               end if
            end if
         case KEY.PGUP                                             'Page-up key
            if ckvl(0) > ckey(26) and ckvl(0) <> ckey(22) then
               ikeycnt = 0                         'initialize file-key counter
               lset ckey(0) = ckvl(0)                  'fill current-key buffer
               istat = ibr.btrv(BTRV.GETLTKEY, crcd(1, 0), _'get rcd. from file
               crcd(0, 0), iptr(4, 0), ckey(0), iptr(7, 0))
               i = ibr.mask(ckey(10), ckey(24), ckey(25), ckey(0), ckey(20))
               if istat = 0 and ckey(24) >= ckey(25) then   'prior record found
                  do while istat = 0 and ckey(24) >= ckey(25) _
                  and ikeycnt < bc.rowcnt - abs(bc.holdln) 'get pageful of data
                     ikeycnt = ikeycnt + 1          'increment file-key counter
                     lset ckey(28) = ckey(0)       'hold lowest key value found
                     istat = ibr.btrv(BTRV.GETPREVKEY, crcd(1, 0), _
                     crcd(0, 0), iptr(4, 0), ckey(0), iptr(7, 0)) 'get prev.key
                     i = ibr.mask(ckey(10), ckey(24), ckey(25), ckey(0), ckey(20))
                  loop
                  lset ckey(0) = ckey(28)      'begin at lowest key value found
                  ikey = KEY.GFPOS                     'set "user" key to GFPOS
               else                                     'prior record NOT found
                  ikey = KEY.HOME                       'set "user" key to HOME
               end if
               ibypass = not 0                       'set keyboard bypass to ON
            end if
         case KEY.PRINT                                   'Print-activation key
            if not bc.prinit then                 'printing not yet initialized
               i = io.vmsg("Print to (P)rinter or (D)isk?", bc.rowmax, bc.clrmsg)
               i = io.vcsr(bc.rowmax, bc.colmin, 0)      'reposition the cursor
               do while ikey <> KEY.ESC            'loop until selection or Esc
                  beep                                         'user-alert tone
                  ikey = io.kget(0)                  'wait for user-pressed key
                  lset bc.prnt = ucase$(char(ikey))      'print-dest. selection
                  if bc.prnt = "P" or bc.prnt = "D" then 'dest.=printer or disk
                     bc.uniprt = freefile                   'save file-unit no.
                     if bc.prnt = "P" then                'printer was selected
                        open "lpt1" for output as bc.uniprt   'open the printer
                     else                                 'disk output selected
                        open "textbrow.prt" for output as bc.uniprt  'open file
                     end if
                     bc.prinit = not 0        'set print-initialization flag ON
                     exit do               'exit the destination-selection loop
                  end if
               loop
            end if
            if bc.prinit then                    'printing has been initialized
               iprtset = not 0                       'set print-mode flag to ON
               lset ckey(27) = ckvl(0)              'save the current key value
               i = io.vmsg("Move bar to last record to print", bc.rowmax, bc.clrmsg)
               i = io.vdsp("and press Enter to select.", bc.rowmax, 33, bc.clrmsg)
               i = io.vdsp("Esc-exit print.", bc.rowmax, 61, bc.clrmsg)
               beep                                            'user-alert tone
            else
               i = io.vmsg(space$(bc.colmin) + bc.cllt + _      'restore border
               cvdb(26) + bc.clrt, bc.rowmax, bc.clrwin)      'when Esc-key hit
            end if
         case else       'alpha (search) keys; print-begin or toggle; exit keys
            if ikey >= 32 and ikey <= 127 and iedtcol < iptr(6, 10) then
               ibufkey = not 0                   'set buffered keyboard flag ON
               do while ikey >= 32 and ikey <= 127 and iedtcol < iptr(6, 10)
                  mid$(cdat(6, 0), iedtcol - iptr(5, 10) + 1) = char(ikey)
                  if iedtcol = iptr(5, 10) then  'put char. into buffer [above]
                     i = io.vdsp(cdat(6, 0), iedtrow, iedtcol, bc.clredt)
                  else     'edit position = 1st position; display field [above]
                     i = io.vdsp(char(ikey), iedtrow, iedtcol, bc.clredt)
                  end if     'edit pos. > 1st pos.; display 1 character [above]
                  iedtcol = iedtcol + 1                'increment edit position
                  iedtlen = iedtcol - iptr(5, 10)          'current edit length
                  ikey = io.ktst(0)              'get the next key (don't wait)
               loop
               lset ckey(0) = ucase$(cdat(6, 0))            'uppercase the data
               if left$(ckey(0), iedtlen) <> left$(ckvl(0), iedtlen) then
                  ipos = iptr(8, 10) + 1                   'set the key-pointer
                  if ipos <= ikeylen then            'key-pointer <= key-length
                     mid$(ckey(0), ipos) = ckey(26)    'fill out key with NULLs
                  end if
                  istat = ibr.btrv(BTRV.GETGEKEY, crcd(1, 0), _
                  crcd(0, 0), iptr(4, 0), ckey(0), iptr(7, 0))   'get file data
                  if istat then              'status = EOF (no further records)
                     ikey = KEY.END                      'set "user" key to END
                     ibypass = not 0                 'set keyboard bypass to ON
                  else                              'subsequent record(s) found
                     i = ibr.mask(ckey(10), ckey(24), ckey(25), ckey(0), ckey(20))
                     if ckey(0) <> ckvl(0) then         'data found <> 1st line
                        if ckey(24) < ckey(25) then    'data found < data range
                           ikey = KEY.HOME              'set "user" key to HOME
                        else                      'data found within data range
                           ikey = KEY.GFPOS            'set "user" key to GFPOS
                        end if
                        ibypass = not 0              'set keyboard bypass to ON
                     end if
                  end if
               end if
            else                  'print-begin or toggle key (Enter); exit keys
               if iprtset then                                'print mode is ON
                  if ikey = KEY.ENTER then    'Enter selects end of print range
                     i = ibr.mask(ckey(10), ckey(24), ckey(25), ckvl(0), ckey(27))
                     if ckey(24) >= ckey(25) then   'final record >= 1st record
                        i = io.vmsg("Press any key to begin printing.", _
                        bc.rowmax, bc.clrmsg)            'begin-printing prompt
                        i = io.vcsr(bc.rowmax, bc.colmin, 0) 'reposition cursor
                        beep                                   'user-alert tone
                        ikey = io.kget(0)            'wait for user-pressed key
                        if ikey <> KEY.ESC then       'OK to proceed with print
                           i = io.vmsg("Please standby", bc.rowmax, bc.clrmsg + 128)
                           bc.linect = 99       'initialize print-lines counter
                           bc.pagect = 0        'initialize page-number counter
                           bc.prtque = not 0       'set printing active flag ON
                           lset ckey(0) = ckey(27)'begin at 1st selected record
                           istat = ibr.btrv(BTRV.GETGE, crcd(1, 0), _'getRecord
                           crcd(0, 0), iptr(4, 0), ckey(0), iptr(7, 0))
                           i = ibr.mask(ckey(10), ckey(24), ckey(25), ckey(0), ckvl(0))
                           do while istat = 0 and ckey(24) _
                           <= ckey(25) and ikey <> KEY.ESC    'print-range loop
                              i = ibr.disp(bc, cdat(), _   'print the data-line
                              ckey(), crcd(), cvdb(), iptr())
                              istat = ibr.btrv(BTRV.GETNEXT, crcd(1, 0), _
                              crcd(0, 0), iptr(4, 0), ckey(0), iptr(7, 0))
                              i = ibr.mask(ckey(10), ckey(24), ckey(25), ckey(0), ckvl(0))
                              if io.ktst(0) = KEY.ESC then   'abort-key pressed
                                 ikey = KEY.ESC      'set key to abort printing
                              end if
                           loop
                        end if
                        bc.prtque = 0         'end of print; set print mode OFF
                        iprtset = 0               'set printing-active flag OFF
                     else                    'error: last record < first record
                        i = io.vmsg("Record selected is prior", bc.rowmax, bc.clrerr)
                        i = io.vdsp("to first record.", bc.rowmax, 25, bc.clrerr)
                        i = io.vdsp("Please retry.", bc.rowmax, 43, bc.clrerr)
                        beep                                   'user-alert tone
                     end if
                  else                        'print-mode ON; non-Enter key hit
                     if ikey = KEY.ESC then            'print-abort key pressed
                        iprtset = 0               'set printing-active flag OFF
                     end if
                  end if
                  if not iprtset then                        'print-mode is OFF
                     if bc.linect then               'line(s) have been printed
                        bc.linect = 0                'reset print-lines counter
                        if bc.prnt = "P" then           'flag=output to printer
                           print #bc.uniprt, char(12);            'do page-feed
                        end if
                     end if
                     i = io.vmsg(space$(bc.colmin) + bc.cllt + _'restore border
                     cvdb(26) + bc.clrt, bc.rowmax, bc.clrwin)  'after printing
                  end if
               else                              'toggle (Enter) key; exit keys
                  if ikey = bc.xkey01 or ikey = bc.xkey02 _ 'If a Browse "quit"
                  or ikey = bc.xkey03 or ikey = bc.xkey04 _ 'key was pressed...
                  or ikey = bc.xkey05 or ikey = bc.xkey06 then
                     bc.auxkey = ikey           'return key# to calling program
                     iexit = not 0                'set exit-from-Browse flag ON
                  end if
               end if
            end if
      end select
      if iexit then                                'exit-from-Browse flag is ON
         exit do                                      'exit the Browse function
      end if
   loop
   lset ckey(0) = ckvl(0)                'return 1st-row key to calling program
   indx = 0                                        'loop thru the search-fields
   iptr(5, indx + 10) = iptr(5, indx + 10) - bc.colmin     'reset begin-columns
   indx = 0                                       'loop thru the display-fields
   iptr(2, indx) = iptr(2, indx) - bc.padadj            'reset the field-widths
end function

function ibr.bkey(cfcb, cmp2, ilen, lrcd) static        'get a key buffer value
   if midchar(cfcb, 3) = 0 then                   'this routine not initialized
      mid$(cfcb, 3) = "1"                               'initialize the routine
      ifile01 = midchar(cfcb, 1)                      'text-file channel number
      ifile02 = midchar(cfcb, 2)                     'index-file channel number
      itxtlen = cvi(mid$(cfcb, 11, 2))             'length of a "block" of text
      iwrdlen = cvi(mid$(cfcb, 15, 2))                     'maximum word length
      llof = lof(ifile01) - 2                   'last text position in the file
      clof = space$(1)                                   'temporary file buffer
      get ifile01, llof, clof                          'load the last character
      if clof = char(13) then                   'last character=carriage return
         llof = llof - 1                          'decrement last text position
      end if
      cdat = space$(itxtlen)                                  'text-file buffer
      cmp3 = mid$(cfcb, 129)                             'valid word characters
      cndx = space$(4)                                       'index-file buffer
   end if
   get ifile02, lrcd, cndx                                 'get an index record
   mid$(cndx, 4) = char(0)                 'add high byte (not present in file)
   lloc = cvl(cndx) + 1                      'actual word position in text file
   get ifile01, lloc, cdat                           'fill the text-file buffer
   if llof - lloc + 1 < itxtlen then            'EOF occurs prior to buffer end
      mid$(cdat, llof - lloc + 2) = " "             'terminate buffer after EOF
   end if
   lset cmp2 = ucase$(left$(cdat, iwrdlen))                'fill the key buffer
   for ichr = 2 to iwrdlen                            'loop thru the key buffer
      if instr(cmp3, char(midchar(cmp2, ichr))) = 0 then  'not valid word char.
         mid$(cmp2, ichr) = space$(iwrdlen)      'clear remainder of key buffer
         exit for                                     'exit the key-buffer loop
      end if
   next
   ilen = ichr - 1                                      'length of current word
   mid$(cmp2, iwrdlen + 1) = mkl$(lrcd)         'add index record number to key
end function

function ibr.brcd(cbuf, cfcb, iwrdpos, lrcd) static        'get a record buffer
   if midchar(cfcb, 4) = 0 then                   'this routine not initialized
      mid$(cfcb, 4) = "1"                               'initialize the routine
      ifile01 = midchar(cfcb, 1)                      'text-file channel number
      ifile02 = midchar(cfcb, 2)                     'index-file channel number
      ioffset = cvi(mid$(cfcb, 13, 2))              'text-offset value (if any)
      itxtlen = cvi(mid$(cfcb, 11, 2))             'length of a "block" of text
      llof = lof(ifile01) - 2                   'last text position in the file
      clof = space$(1)                                   'temporary file buffer
      get ifile01, llof, clof                          'load the last character
      if clof = char(13) then                   'last character=carriage return
         llof = llof - 1                          'decrement last text position
      end if
      iadjust = ioffset + 2          'distance to text past c/r-l/f-plus-offset
      ibuflen = len(cbuf)                     'length of the data-record buffer
      ibufofs = ibuflen - 1                        'temporary calculation value
      ibufseg = ibuflen \ 2                        'temporary calculation value
      cdat = space$(itxtlen * 2)                              'text-file buffer
      cndx = space$(4)                                       'index-file buffer
      ctxt = space$(itxtlen)                          'single-block text buffer
   end if
   get ifile02, lrcd, cndx                                 'get an index record
   mid$(cndx, 4) = char(0)                 'add high byte (not present in file)
   mid$(cfcb, 17) = cndx                'save actual word position (-1) in cfcb
   lloc = cvl(cndx) + 1                      'actual word position in text file
   if lloc > itxtlen + ioffset then   'text-begin is greater than buffer length
      get ifile01, lloc - itxtlen, cdat  'load buffer from text-begin - itxtlen
      iwrdpos = itxtlen + 1            'actual word position in the text buffer
   else                      'text-begin is less than or equal to buffer length
      if lloc > ibufseg + ioffset then   'text-begin is in last half of display
         get ifile01, lloc - ibufseg, ctxt 'load text from text-begin - ibufseg
         iwrdpos = itxtlen + ibufseg + 1   'actual word position in text buffer
      else                         'text-begin is in first half of display line
         get ifile01, clng(ioffset) + 1, ctxt   'load text from byte #1 in file
         iwrdpos = lloc + itxtlen - ioffset'actual word position in text buffer
      end if                       'put LF chars, then text into buffer [below]
      lset cdat = string$(itxtlen - ioffset, 10) + space$(ioffset) + ctxt
   end if
   if llof - lloc + iwrdpos < itxtlen * 2 then  'EOF occurs prior to buffer end
      mid$(cdat, llof - lloc + iwrdpos + 1) = string$(2, 13)
   end if                        'put terminators into buffer after EOF [above]
   ipos1 = instr(iwrdpos, cdat, char(13))
   if ipos1 = 0 then
      ipos1 = itxtlen * 2 + 1
   end if
   ipos2 = instr(ipos1 + 1, cdat, char(13))
   if ipos2 < ipos1 + iadjust then
      ipos2 = ipos1 + iadjust
   end if
   lset cbuf = mid$(cdat, iwrdpos, ipos1 - iwrdpos) + " " + _
   ltrim$(mid$(cdat, ipos1 + iadjust, ipos2 - ipos1 - iadjust))
   iwrdpos = ipos1 - iwrdpos + 1
end function

function ibr.btrv(ioper, cfcb, cbuf, ilen, ckey, ikey) static 'get a key or rcd
   istat = 0                               'initialize the call-status variable
   select case ioper                                'file-access operation code
      case BTRV.GETEQ, _                       'get record = supplied key value
           BTRV.GETEQKEY, _                       'get key = supplied key value
           BTRV.GETGE, _                      'get record >= supplied key value
           BTRV.GETGEKEY, _                      'get key >= supplied key value
           BTRV.GETLE, _                      'get record <= supplied key value
           BTRV.GETLEKEY                         'get key <= supplied key value
         lrcd = cvl(mid$(ckey, iwrdlen + 1) + char(0))    'current index record
         if lrcd then               'supplied key contained an index record no.
            i = ibr.bkey(cfcb, cmp2, ilen, lrcd)          'get the matching key
            select case ioper                       'file-access operation code
               case BTRV.GETGE, _             'get record >= supplied key value
                    BTRV.GETLE                'get record <= supplied key value
                  ioper = BTRV.GETEQ        'get equal when index rcd# supplied
               case BTRV.GETGEKEY, _             'get key >= supplied key value
                    BTRV.GETLEKEY                'get key <= supplied key value
                  ioper = BTRV.GETEQKEY     'get equal when index rcd# supplied
               case else
            end select
         end if
      case BTRV.GETGT, _                       'get record > supplied key value
           BTRV.GETGTKEY, _                       'get key > supplied key value
           BTRV.GETLT, _                       'get record < supplied key value
           BTRV.GETLTKEY                          'get key < supplied key value
         lrcd = cvl(mid$(ckey, iwrdlen + 1) + char(0))    'current index record
         if lrcd then               'supplied key contained an index record no.
            mid$(cfcb, 7) = mkl$(lrcd)      'update the index in the fcb buffer
            select case ioper                       'file-access operation code
               case BTRV.GETGT                 'get record > supplied key value
                  ioper = BTRV.GETNEXT        'getnext when index rcd# supplied
               case BTRV.GETGTKEY                 'get key > supplied key value
                  ioper = BTRV.GETNEXTKEY 'getnext key when index rcd# supplied
               case BTRV.GETLT                 'get record < supplied key value
                  ioper = BTRV.GETPREV        'getprev when index rcd# supplied
               case BTRV.GETLTKEY                 'get key < supplied key value
                  ioper = BTRV.GETPREVKEY 'getprev key when index rcd# supplied
               case else
            end select
         end if
      case else
   end select
   select case ioper                                'file-access operation code
      case BTRV.GETGE, _                      'get record >= supplied key value
           BTRV.GETGEKEY, _                      'get key >= supplied key value
           BTRV.GETGT, _                       'get record > supplied key value
           BTRV.GETGTKEY, _                       'get key > supplied key value
           BTRV.GETLE, _                      'get record <= supplied key value
           BTRV.GETLEKEY, _                      'get key <= supplied key value
           BTRV.GETLT, _                       'get record < supplied key value
           BTRV.GETLTKEY                          'get key < supplied key value
         lset cmp1 = ckey                       'load the key-comparison buffer
         ltop = lrcds + 1                  'set the top value for binary search
         llow = 0                          'set the low value for binary search
         do while ltop - llow > 1                  'loop until search exhausted
            lmid = llow + (ltop - llow) \ 2      'set the middle (search) value
            lrcd = lmid * 3 - 2                    'set the index record number
            i = ibr.bkey(cfcb, cmp2, ilen, lrcd)      'get the key-buffer value
            i = ibr.mask(cmsk, cmp3, cmp4, cmp1, cmp2)     'mask the key buffer
            if cmp3 <= cmp4 then            'current key <= key found in search
               ltop = lmid                            'move the search downward
            else                             'current key > key found in search
               llow = lmid                              'move the search upward
            end if
         loop
         if ioper = BTRV.GETLT or ioper = BTRV.GETLTKEY then    'operation code
            if llow > 0 and llow <> lmid then      'get low value when low<>mid
               lrcd = llow * 3 - 2                 'set the index record number
               i = ibr.bkey(cfcb, cmp2, ilen, lrcd)   'get the key-buffer value
               i = ibr.mask(cmsk, cmp3, cmp4, cmp1, cmp2)  'mask the key buffer
            end if
         else
            if ltop <= lrcds and ltop <> lmid then 'get top value when top<>mid
               lrcd = ltop * 3 - 2                 'set the index record number
               i = ibr.bkey(cfcb, cmp2, ilen, lrcd)   'get the key-buffer value
               i = ibr.mask(cmsk, cmp3, cmp4, cmp1, cmp2)  'mask the key buffer
            end if
         end if
      case BTRV.GETNEXT, _             'get next record from supplied key value
           BTRV.GETNEXTKEY                'get next key from supplied key value
         lrcd = cvl(mid$(cfcb, 7, 4))       'get the index record# from the fcb
         if (lrcd + 2) \ 3 < lrcds then         'a next record/key is available
            lrcd = lrcd + 3                      'increment the "record" number
            i = ibr.bkey(cfcb, cmp2, ilen, lrcd)      'get the key-buffer value
         else                               'a next record/key is NOT available
            istat = 2                              'set the return-status error
         end if
      case BTRV.GETPREV, _            'get prev. record from supplied key value
           BTRV.GETPREVKEY               'get prev. key from supplied key value
         lrcd = cvl(mid$(cfcb, 7, 4))       'get the index record# from the fcb
         if (lrcd + 2) \ 3 > 1 then         'a previous record/key is available
            lrcd = lrcd - 3                      'decrement the "record" number
            i = ibr.bkey(cfcb, cmp2, ilen, lrcd)      'get the key-buffer value
         else                           'a previous record/key is NOT available
            istat = 2                              'set the return-status error
         end if
      case BTRV.OPEN                             'open the text and index files
         idotpos = instr(ckey, ".")             'position of filename extension
         if idotpos = 0 then                        'an extension was NOT found
            idotpos = len(rtrim$(ckey)) + 1      'set position to key length +1
         end if
         ifile01 = freefile                      'get the text file channel no.
         open ckey for binary as ifile01                    'open the text file
         ifile02 = freefile                     'get the index file channel no.
         open left$(ckey, idotpos - 1) + ".ptr" for binary as ifile02'indx.file
         lrcds = (lof(ifile02) - 4) \ 3             'total no. of indexed words
         iwrdlen = cvi(mid$(cfcb, 15, 2))                  'maximum word length
         cmp1 = string$(iwrdlen + 3, 0)                  'key-comparison buffer
         cmp2 = cmp1                                     'key-comparison buffer
         cmp3 = cmp1                                     'key-comparison buffer
         cmp4 = cmp1                                     'key-comparison buffer
         cmsk = string$(iwrdlen, "C") + "SSS"               'key-masking string
         cnul = cmp1                                     'NULL key-filler bytes
         mid$(cfcb, 1) = char(ifile01)          'save the text file channel no.
         mid$(cfcb, 2) = char(ifile02)         'save the index file channel no.
      case BTRV.RESET                           'close the text and index files
         close ifile01                                     'close the text file
         close ifile02                                    'close the index file
      case else
   end select
   select case ioper                                'file-access operation code
      case BTRV.GETGE, _                      'get record >= supplied key value
           BTRV.GETGEKEY                         'get key >= supplied key value
         if cmp3 > cmp4 then                 'current key > key found in search
            istat = 2                              'set the return-status error
         end if
      case BTRV.GETGT, _                       'get record > supplied key value
           BTRV.GETGTKEY                          'get key > supplied key value
         if cmp3 = cmp4 then                 'current key = key found in search
            if ltop < lrcds then                'a next record/key is available
               lrcd = ltop * 3 + 1                 'set the index record number
               i = ibr.bkey(cfcb, cmp2, ilen, lrcd)   'get the key-buffer value
               i = ibr.mask(cmsk, cmp3, cmp4, cmp1, cmp2)  'mask the key buffer
            end if
         end if
         if cmp3 >= cmp4 then               'current key >= key found in search
            istat = 2                              'set the return-status error
         end if
      case BTRV.GETLE, _                      'get record <= supplied key value
           BTRV.GETLEKEY                         'get key <= supplied key value
         if cmp3 < cmp4 then                 'current key < key found in search
            if llow > 0 and llow <> lmid then      'get low value when low<>mid
               lrcd = llow * 3 - 2                 'set the index record number
               i = ibr.bkey(cfcb, cmp2, ilen, lrcd)   'get the key-buffer value
               i = ibr.mask(cmsk, cmp3, cmp4, cmp1, cmp2)  'mask the key buffer
            end if
         end if
         if cmp3 < cmp4 then                 'current key < key found in search
            istat = 2                              'set the return-status error
         end if
      case BTRV.GETLT, _                       'get record < supplied key value
           BTRV.GETLTKEY                          'get key < supplied key value
         if cmp3 <= cmp4 then               'current key <= key found in search
            istat = 2                              'set the return-status error
         end if
      case else
   end select
   select case ioper                                'file-access operation code
      case BTRV.GETEQ, _                       'get record = supplied key value
           BTRV.GETGE, _                      'get record >= supplied key value
           BTRV.GETGT, _                       'get record > supplied key value
           BTRV.GETLE, _                      'get record <= supplied key value
           BTRV.GETLT, _                       'get record < supplied key value
           BTRV.GETNEXT, _             'get next record from supplied key value
           BTRV.GETPREV               'get prev. record from supplied key value
         if istat then                           'a return-status error was set
            lset ckey = cnul               'return key buffer filled with NULLs
         else                                'a return-status error was NOT set
            i = ibr.brcd(cbuf, cfcb, iwrdpos, lrcd) 'get the data-record buffer
            mid$(cfcb, 7) = mkl$(lrcd)     'save the current index "record" no.
            lset ckey = cmp2           'put key-comparison buffer to key buffer
            ikey = iwrdpos                  'return word-begin position in key#
         end if
      case BTRV.GETEQKEY, _                       'get key = supplied key value
           BTRV.GETGEKEY, _                      'get key >= supplied key value
           BTRV.GETGTKEY, _                       'get key > supplied key value
           BTRV.GETLEKEY, _                      'get key <= supplied key value
           BTRV.GETLTKEY, _                       'get key < supplied key value
           BTRV.GETNEXTKEY, _             'get next key from supplied key value
           BTRV.GETPREVKEY               'get prev. key from supplied key value
         if istat then                           'a return-status error was set
            lset ckey = cnul               'return key buffer filled with NULLs
         else                                'a return-status error was NOT set
            mid$(cfcb, 7) = mkl$(lrcd)     'save the current index "record" no.
            lset ckey = cmp2           'put key-comparison buffer to key buffer
         end if
      case else
   end select
   ibr.btrv = istat             'return the error status to the calling program
end function

function ibr.cdat(bc as bcnf, ckey(), ckvl(), cvdb())   'clear unused data-rows
   for irow = bc.dsprow + 1 to bc.rowcnt - 1        'loop thru unused data-rows
      lset ckvl(irow) = ckey(26)                     'clear data-row key buffer
      lset cvdb(irow) = cvdb(23)                   'clear data-row video buffer
      i = io.vdsp(cvdb(23), bc.rowbeg + irow, bc.colmin + 1, bc.clrdat)
   next
end function

function ibr.disp(bc as bcnf, cdat(), ckey(), crcd(), cvdb(), iptr())'disp.data
   ipos = 1 + abs(bc.padext) + abs(bc.padint)   '1st position in cvdb(24 or 25)
   ifld = 0                                'loop thru the data fields (columns)
   if bc.prtque then                            'print-mode ON; printing active
      indx = 25                                         'index for print-buffer
   else                                        'print mode is OFF, display only
      indx = 24                                         'index for video-buffer
   end if                                     'put field-data to buffer [below]
   mid$(cvdb(indx), ipos) = mid$(crcd(0, 0), iptr(0, ifld), iptr(1, ifld))
   ipos = ipos + iptr(2, ifld) + 1                   'increment buffer-position
   iwrdpos = iptr(7, 0)                         'text word begin in data buffer
   iwrdlen = iptr(4, 0)                        'text word length in data buffer
   if bc.prtque then                            'print-mode ON; printing active
      if bc.linect >= 59 and bc.prnt = "P" then        'maximum lines/page = 59
         bc.pagect = bc.pagect + 1                      'increment page-counter
         lset bc.page = ltrim$(str$(bc.pagect))       'fill page-counter buffer
         i = ibr.time(left$(time$, 2) + mid$(time$, 4, 2), bc.time)'format time
         lset cprt = date$                              'print the current date
         mid$(cprt, bc.hdrpos) = cdat(0, 0)             'print the header title
         mid$(cprt, 70) = "Page: "                      'print page-field title
         mid$(cprt, 76) = bc.page                        'print the page-number
         if bc.pagect >= 2 then                          'current page# is >= 2
            print #bc.uniprt, char(12);              'page-feed when page# >= 2
         end if
         print #bc.uniprt, cprt           'print date, title, page# on 1st line
         print #bc.uniprt, bc.time                  'print time-of-day 2nd line
         print #bc.uniprt, ""                        'print blank line 3rd line
         bc.linect = 3 + bc.titles                 'accumulated lines this page
      end if
'      print #bc.uniprt, cdat(4, 0);                'print-bold ON code (if any)
      print #bc.uniprt, mid$(cvdb(25), 1, iwrdlen)
'      print #bc.uniprt, cdat(5, 0);               'print-bold OFF code (if any)
'      print #bc.uniprt, mid$(cvdb(25), 1 + iwrdlen)
      bc.linect = bc.linect + 1                  'increment print-lines counter
   else                                        'print mode is OFF, display only
      lset cvdb(bc.dsprow) = cvdb(24)           'put display-data to row-buffer
      if bc.dsprow = 0 and bc.auxkey <> 0 then 'bc.auxkey set to stay in Browse
         icolor1 = bc.clrbar                 'set row-color to scroll-bar color
         icolor2 = bc.clrdat                       'set row-color to data color
      else                                     'bc.auxkey set to display & exit
         icolor1 = bc.clrdat                       'set row-color to data color
         icolor2 = bc.clrbar                 'set row-color to scroll-bar color
      end if                                      'display the data-row [below]
      iptr(7, bc.dsprow + 1) = iwrdpos                'save the hilite location
      iptr(4, bc.dsprow + 1) = iwrdlen                  'save the hilite length
      i = io.vdsp(cvdb(24), bc.rowbeg + bc.dsprow, bc.colmin + 1, icolor1)
      i = io.vdsp(mid$(cvdb(24), 1, iwrdlen), _
      bc.rowbeg + bc.dsprow, bc.colmin + 1, icolor2)
   end if
end function

function ibr.hkey(ckey(), ckvl(), crcd(), iptr())   'get high key in data range
   lset ckey(0) = ckey(21)                      'begin at max. allow. key-value
   istat = ibr.btrv(BTRV.GETLEKEY, crcd(1, 0), _
   crcd(0, 0), iptr(4, 0), ckey(0), iptr(7, 0))   'get 1st record <= max. value
   i = ibr.mask(ckey(10), ckey(24), ckey(25), ckey(0), ckey(20))  'mask the key
   if istat = 0 and ckey(24) >= ckey(25) then      'record found & within range
      lset ckey(23) = ckey(0)                'return highest key-value in range
   else                                   'record NOT found or NOT within range
      lset ckey(23) = ckey(26)                           'return NULL key-value
   end if
end function

function ibr.lkey(ckey(), ckvl(), crcd(), iptr())    'get low key in data range
   lset ckey(0) = ckey(20)                      'begin at min. allow. key-value
   istat = ibr.btrv(BTRV.GETGEKEY, crcd(1, 0), _
   crcd(0, 0), iptr(4, 0), ckey(0), iptr(7, 0))   'get 1st record >= min. value
   i = ibr.mask(ckey(10), ckey(24), ckey(25), ckey(0), ckey(21))  'mask the key
   if istat = 0 and ckey(24) <= ckey(25) then      'record found & within range
      lset ckey(22) = ckey(0)                 'return lowest key-value in range
   else                                   'record NOT found or NOT within range
      lset ckey(22) = ckey(26)                           'return NULL key-value
   end if
end function

function ibr.mask(cmask, ccmp1, ccmp2, cstr1, cstr2)    'reverse "SSS" segments
   ipos = instr(cmask, "SSS")                    'last position to uppercase +1
   mid$(cstr1, 1) = ucase$(left$(cstr1, ipos - 1))  'convert cstr1 to uppercase
   lset ccmp1 = cstr1                       'put key1 value into compare-buffer
   lset ccmp2 = cstr2                       'put key2 value into compare-buffer
   mid$(ccmp1, ipos) = char(midchar(cstr1, ipos + 2))       'swap the 'S' bytes
   mid$(ccmp1, ipos + 2) = char(midchar(cstr1, ipos))   'in 1st & 3rd positions
   mid$(ccmp2, ipos) = char(midchar(cstr2, ipos + 2))       'swap the 'S' bytes
   mid$(ccmp2, ipos + 2) = char(midchar(cstr2, ipos))   'in 1st & 3rd positions
end function

function ibr.scrl(bc as bcnf, ckvl(), cvdb(), iptr())   'scroll data up or down
   if bc.scroll < 0 then                                   'scroll data-rows up
      itop = 0                                         'begin scroll at 1st row
      ilow = bc.dsprow - 1                           'end scroll at last row -1
   else                                                  'scroll data-rows down
      itop = bc.dsprow + abs(bc.dsprow < bc.rowcnt - 1) 'begin scroll @last row
      ilow = 1                                           'end scroll at 2nd row
   end if
   for irow = itop to ilow step -sgn(bc.scroll)        'loop thru the data-rows
      if irow > 0 then                                   'loop-row is > 1st row
         icolor1 = bc.clrdat                           'set color to data-color
         icolor2 = bc.clrbar                           'set color to data-color
      else                                                 'loop-row is 1st row
         icolor1 = bc.clrbar                     'set color to scroll-bar-color
         icolor2 = bc.clrdat                     'set color to scroll-bar-color
      end if
      lset ckvl(irow) = ckvl(irow - bc.scroll)       'shift data-row key buffer
      lset cvdb(irow) = cvdb(irow - bc.scroll)     'shift data-row video buffer
      iptr(7, irow + 1) = iptr(7, irow + 1 - bc.scroll) 'shift hilite locations
      iptr(4, irow + 1) = iptr(4, irow + 1 - bc.scroll)   'shift hilite lengths
      iwrdpos = iptr(7, irow + 1)               'text word begin in data buffer
      iwrdlen = iptr(4, irow + 1)              'text word length in data buffer
      i = io.vdsp(cvdb(irow), bc.rowbeg + irow, bc.colmin + 1, icolor1)
      i = io.vdsp(mid$(cvdb(irow), 1, iwrdlen), _
      bc.rowbeg + irow, bc.colmin + 1, icolor2)
   next
end function

function ibr.scrn(bc as bcnf, cdat(), cvdb(), iptr())    'display Browse window
   if bc.linext then                            'OK to clear Browse-window area
      i = io.vcls(bc.rowmin, bc.colmin, bc.rowmax, _
      bc.colmax, bc.linext, 1, bc.clrwin)              'clear the Browse-window
   end if
   if bc.hdrrow then                           'OK to disp. header-title in box
      i = io.vcls(bc.rowmin + 1, bc.colmin + 2, _   'clear the header-title row
      bc.rowmin + 1, bc.colmax - 2, 0, 1, bc.clrhdr)
      i = io.vdsp(cdat(0, 0), bc.rowmin + 1, bc.hdrcol, bc.clrhdr)'disp. header
      i = io.vdsp(bc.cdtl + cvdb(26) + bc.cdtr, _
      bc.rowmin + 2, bc.colmin, bc.clrwin)          'disp. bottom of header-box
   end if
   i = io.vcls(bc.rowbeg, bc.colmin + 1, _       'clear Browse-window data area
   bc.rowend, bc.colmax - 1, 0, 1, bc.clrdat)
   if bc.edtmax >= 0 then                        'search field(s) are available
      i = io.vdsp(bc.cstl + string$(bc.colcnt, "-") _
      + bc.cstr, bc.rowend + 1, bc.colmin, bc.clrwin)    'line under search-row
   end if
   if bc.ftrcnt then                           'footer message(s) are available
      i = io.vdsp(bc.cstl + string$(bc.colcnt, "-") + bc.cstr, _
      bc.rowmax - bc.ftrcnt - 1, bc.colmin, bc.clrwin)  'line above footer area
      i = io.vcls(bc.rowmax - bc.ftrcnt, bc.colmin + 2, _
      bc.rowmax - 1, bc.colmax - 2, 0, 1, bc.clrftr)  'clear Browse footer area
   end if
   if not bc.hdrrow then         'OK to disp. header-title on top window-border
      i = io.vdsp(cdat(0, 0), bc.rowmin, bc.hdrcol, bc.clrhdr)  'display header
   end if
   irow = bc.rowmax - bc.ftrcnt - 1        'initialize row# for footer-messages
   for indx = 3 to 5                             'loop thru the footer-messages
      if len(cdat(0, indx)) then            'footer-message exists @ this index
         irow = irow + 1                    'increment row# when message exists
         i = io.vdsp(cdat(0, indx), irow, bc.ftrcol, bc.clrftr)'display message
      end if
   next
end function

function ibr.time(ctimein, ctimeout)                  'format time from ctimein
   lset ctimeout = left$(ctimein, 2) + ":" + right$(ctimein, 2) + "a"
   if left$(ctimeout, 2) >= "12" then                       'time-in is >= noon
      mid$(ctimeout, 6) = "p"                             'set am/pm flag to pm
      if left$(ctimeout, 2) > "12" then                     'time-in is >= 1 pm
         ival = pdqvali(left$(ctimeout, 2)) - 12          'adjusted hours value
         mid$(ctimeout, 1) = right$(str$(ival), 2)'chg. 24-hour time to 12-hour
      end if
   else                                                      'time-in is < noon
      if left$(ctimeout, 2) = "00" then                      'time-in is < 1 am
         mid$(ctimeout, 1) = "12"                    'set hour to 12 (midnight)
      else                                                  'time-in is >= 1 am
         if left$(ctimeout, 1) = "0" then                   'time-in is < 10 am
            mid$(ctimeout, 1) = " "                    'blank lead-zero in hour
         end if
      end if
   end if
end function
